C     Last change:  ERB  11 Feb 2002    1:40 pm
      PROGRAM PBUF
C  PRINT BUDGET READ FROM UNFORMATTED FILES FROM MODULAR MODEL
C
C  WRITTEN BY ARLEN W. HARBAUGH
C  MODIFIED BY NED BANTA
C
C  INPUT COMES ON UNIT 10 -- IE THE MODEL DATA FILE, WHICH HOLDS
C  THE HEAD OR DD DATA.
C  OUTPUT GOES TO UNIT 11.
C
      CHARACTER*40 VERSION
      PARAMETER (VERSION='PBUF version 1.4 2002/02/11')
      ALLOCATABLE BUF(:)
      ALLOCATABLE IBUF(:)
      CHARACTER*200 LINE
      CHARACTER*80 INNAME, OUTNAME, INNAMU, OUTNAMU
      CHARACTER*30 FMTR, FMTI
      CHARACTER*16 TEXT(6)
      LOGICAL ALLOC, FILEX
      DIMENSION QV(6)
      INCLUDE 'openspec.inc'
C     ------------------------------------------------------------------
  480 FORMAT(/,1X,A,/)
  490 FORMAT(' Enter the name of a file for printing the budget data',/,
     &' (optional: Fortran formats for printing real and integer',
     &' arrays): ',/)
  500 FORMAT(' ERROR: FILE DOES NOT EXIST: ',A)
  505 FORMAT(' MODEL CONTAINS TOO MANY COLUMNS FOR PBUF TO HANDLE BY',
     &' DEFAULT',/,' -- SPECIFY FORMATS AFTER OUTPUT FILE NAME')
  510 FORMAT(' KSTP,KPER,TEXT,NCOL,NROW,NLAY:',2(1X,I4),1X,A,3(1X,I5))
  515 FORMAT(' READING AND WRITING BUDGET COMPONENT: ',A)
  520 FORMAT(' NCOL = ',I10,' NROW = ',I10,' NLAY = ',I10,/,
     &' NOT ENOUGH MEMORY AVAILABLE -- STOP EXECUTION')
  530 FORMAT(' NCB,DELT,PERTIM,TOTIM: ',I3,1P,3(1X,E14.7))
  540 FORMAT(' ERROR: Input and output file names are the same')
  550 FORMAT(1X,A)
  601 FORMAT('(',I1,'(1X,1P,E14.7))',14X)
  602 FORMAT('(',I2,'(1X,1P,E14.7))',13X)
  603 FORMAT('(',I3,'(1X,1P,E14.7))',12X)
  604 FORMAT('(',I4,'(1X,1P,E14.7))',11X)
  605 FORMAT('(',I5,'(1X,1P,E14.7))',10X)
  606 FORMAT('(',I6,'(1X,1P,E14.7))',9X)
  611 FORMAT('(',I1,'(1X,I5))',20X)
  612 FORMAT('(',I2,'(1X,I5))',19X)
  613 FORMAT('(',I3,'(1X,I5))',18X)
  614 FORMAT('(',I4,'(1X,I5))',17X)
  615 FORMAT('(',I5,'(1X,I5))',16X)
  616 FORMAT('(',I6,'(1X,I5))',15X)
  650 FORMAT(1X,I10,' VALUES')
  660 FORMAT(3(1X,I10),6(1X,1P,E14.7))
C
      IN=10
      IOUT=11
      WRITE(*,480) VERSION
C
C     GET FILE NAMES
      WRITE(*,*) ' Enter the name of an unformatted budget file: '
      READ(*,'(A)') INNAME
      IF (INNAME.EQ.' ') STOP
      INQUIRE(FILE=INNAME,EXIST=FILEX)
      IF (.NOT.FILEX) THEN
        WRITE(*,500) INNAME
        STOP
      ENDIF
      OPEN(UNIT=IN,FILE=INNAME,STATUS='OLD',FORM=FORM,ACCESS=ACCESS)
      CALL UCASE(INNAME,INNAMU,1)
   10 CONTINUE
      WRITE(*,490)
      READ(*,'(A200)') LINE
      LLOC=1
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,0,N,R,0,0)
      OUTNAME = LINE(ISTART:ISTOP)
      IF (OUTNAME.EQ.' ') GOTO 10
      CALL UCASE(OUTNAME,OUTNAMU,1)
      IF (INNAMU.EQ.OUTNAMU) THEN
        WRITE(*,540)
        STOP
      ENDIF
      FMTR = ' '
      FMTI = ' '
      IFMTR = 0
      IFMTI = 0
C
C     GET USER-SPECIFIED FORMATS
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,1,N,R,0,0)
      IF (LINE(ISTART:ISTOP).NE.' ') THEN
        FMTR = LINE(ISTART:ISTOP)
        IFMTR = 1
        CALL URWORD(LINE,LLOC,ISTART,ISTOP,1,N,R,0,0)
        IF (LINE(ISTART:ISTOP).NE.' ') THEN
          FMTI = LINE(ISTART:ISTOP)
          IFMTI = 1
        ENDIF
      ENDIF
C
      ALLOC = .FALSE.
   50 CONTINUE
C
C     READ A HEADER RECORD FROM UNFORMATTED FILE
      READ(IN,ERR=1000) KSTP,KPER,TEXT(1),NCOL,NROW,NLAY
      WRITE(*,515) TEXT(1)
C
C     ALLOCATE MEMORY AND OPEN OUTPUT FILE, IF NEEDED
      IF (.NOT.ALLOC) THEN
        NT=NCOL*NROW*ABS(NLAY)
        NRC=NCOL*NROW
        ALLOCATE (BUF(NT),STAT=JBUFSTAT)
        ALLOCATE (IBUF(NRC),STAT=IBUFSTAT)
        IF (JBUFSTAT.NE.0 .OR. IBUFSTAT.NE.0) THEN
          WRITE(*,520) NCOL,NROW,NLAY
          STOP
        ENDIF
        ALLOC = .TRUE.
        IF (FMTI.EQ.' ') THEN
          IF (NCOL.LT.10) THEN
            IF (FMTR.EQ.' ') WRITE(FMTR,601) NCOL
            WRITE(FMTI,611) NCOL
          ELSEIF (NCOL.LT.100) THEN
            IF (FMTR.EQ.' ') WRITE(FMTR,602) NCOL
            WRITE(FMTI,612) NCOL
          ELSEIF (NCOL.LT.1000) THEN
            IF (FMTR.EQ.' ') WRITE(FMTR,603) NCOL
            WRITE(FMTI,613) NCOL
          ELSEIF (NCOL.LT.10000) THEN
            IF (FMTR.EQ.' ') WRITE(FMTR,604) NCOL
            WRITE(FMTI,614) NCOL
          ELSEIF (NCOL.LT.100000) THEN
            IF (FMTR.EQ.' ') WRITE(FMTR,605) NCOL
            WRITE(FMTI,615) NCOL
          ELSEIF (NCOL.LT.1000000) THEN
            IF (FMTR.EQ.' ') WRITE(FMTR,606) NCOL
            WRITE(FMTI,616) NCOL
          ELSE
            IF (FMTR.EQ.' ') THEN
              WRITE(*,505)
              STOP
            ENDIF
          ENDIF
        ENDIF
        IRECL = 225
        IF (NCOL.GT.15 .AND. IFMTR.EQ.0) THEN
          IRECL = NCOL*15
        ELSEIF (NCOL.GT.45 .AND. IFMTI.EQ.0) THEN
          IRECL = NCOL*5
        ENDIF
        OPEN(UNIT=IOUT,FILE=OUTNAME,RECL=IRECL)
      ENDIF
      WRITE(IOUT,510) KSTP,KPER,TEXT(1),NCOL,NROW,NLAY
C  negative NLAY indicates COMPACT BUDGET
      IF (NLAY.LT.0) THEN
        NLAY=-NLAY
C  Read the extra record that defines the compact type
        READ(IN) NCB,DELT,PERTIM,TOTIM
        WRITE(IOUT,530) NCB,DELT,PERTIM,TOTIM
      ELSE
        NCB = 1
        DELT = -9999.9
        PERTIM = -9999.9
        TOTIM = -9999.9
      ENDIF
C
      IF (NCB.EQ.1) THEN
C  Full 3-D array
        READ(IN) (BUF(I),I=1,NT)
        CALL APRINT(BUF,NCOL,NROW,NLAY,IOUT,TEXT(1),KSTP,KPER,PERTIM,
     &              TOTIM,FMTR)
C
      ELSEIF (NCB.EQ.2) THEN
C  List without auxiliary values
        READ(IN) NLIST
        WRITE(IOUT,'(1X,I10)') NLIST
        DO 100 L=1,NLIST
          READ(IN) ICRL,Q
          K= (ICRL-1)/NRC + 1
          I= ((ICRL- (K-1)*NRC)-1)/NCOL + 1
          J= ICRL- (K-1)*NRC - (I-1)*NCOL
          WRITE(IOUT,660) K,I,J,Q
100     CONTINUE
C
      ELSEIF (NCB.EQ.3) THEN
C  2-D array plus a layer indicator array
        READ(IN) (IBUF(I),I=1,NRC)
        READ(IN) (BUF(I),I=1,NRC)
        CALL LPRINT(IBUF,BUF,NCOL,NROW,IOUT,2,TEXT(1),KSTP,KPER,PERTIM,
     &              TOTIM,FMTI,FMTR)
C
      ELSEIF (NCB.EQ.4) THEN
C  2-D array for layer 1
        READ(IN) (BUF(I),I=1,NRC)
        CALL LPRINT(IBUF,BUF,NCOL,NROW,IOUT,1,TEXT(1),KSTP,KPER,PERTIM,
     &              TOTIM,FMTI,FMTR)
C
      ELSEIF (NCB.EQ.5) THEN
C  List with auxiliary values
        READ(IN) NVAL
        WRITE(IOUT,650) NVAL
        IF (NVAL.GT.1) THEN
          READ(IN) (TEXT(N),N=2,NVAL)
          WRITE(IOUT,550) (TEXT(N),N=2,NVAL)
        ENDIF
        READ(IN) NLIST
        WRITE(IOUT,'(1X,I10)') NLIST
        DO 200 L=1,NLIST
          READ(IN) ICRL,(QV(N),N=1,NVAL)
          K= (ICRL-1)/NRC + 1
          I= ((ICRL- (K-1)*NRC)-1)/NCOL + 1
          J= ICRL- (K-1)*NRC - (I-1)*NCOL
          WRITE(IOUT,660) K,I,J,(QV(N),N=1,NVAL)
  200   CONTINUE
      END IF 
C
      GO TO 50
C
 1000 STOP
      END
C ======================================================================
      SUBROUTINE APRINT(BUF,NCOL,NROW,NLAY,IOUT,TEXT,KSTP,KPER,PERTIM,
     &                  TOTIM,FMTR)
C     ******************************************************************
C     Print 3-D array
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      CHARACTER*16 TEXT
      CHARACTER*30 FMTR
      DIMENSION BUF(NCOL,NROW,NLAY)
C     ------------------------------------------------------------------
C
C4------LOOP THROUGH THE ROWS PRINTING EACH ONE IN ITS ENTIRETY.
      DO 1100 K=1,NLAY
        CALL ULASV2(BUF(1,1,K),TEXT,KSTP,KPER,PERTIM,TOTIM,NCOL,
     &                   NROW,K,IOUT,FMTR,1)
1100  CONTINUE
      RETURN
      END
C ======================================================================
      SUBROUTINE LPRINT(IBUF,BUF,NCOL,NROW,IOUT,ILAY,TEXT,KSTP,KPER,
     &                  PERTIM,TOTIM,FMTI,FMTR)
C     ******************************************************************
C     Print 2-D array with or without a layer indicator array
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      CHARACTER*16 TEXT
      CHARACTER*30 FMTI, FMTR
      DIMENSION BUF(NCOL,NROW), IBUF(NCOL,NROW)
C     ------------------------------------------------------------------
C
C4------LOOP THROUGH THE ROWS PRINTING EACH ONE IN ITS ENTIRETY.
      IF (ILAY.EQ.2) THEN
        CALL ULASV3(IBUF,TEXT,KSTP,KPER,PERTIM,TOTIM,NCOL,NROW,0,IOUT,
     &              FMTI,1)
      ENDIF
C
      CALL ULASV2(BUF,TEXT,KSTP,KPER,PERTIM,TOTIM,NCOL,NROW,0,IOUT,FMTR,
     &            1)
C
      RETURN
      END
C ======================================================================
      SUBROUTINE ULASV2(BUFF,TEXT,KSTP,KPER,PERTIM,TOTIM,NCOL,NROW,ILAY,
     &                  IOUT,FMTOUT,LBLSAV)
C
C-----VERSION 07APR2000 ULASV2
C     ******************************************************************
C     SAVE 1 LAYER ARRAY ON DISK USING FORMATTED OUTPUT
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      CHARACTER*16 TEXT
      DIMENSION BUFF(NCOL,NROW)
      CHARACTER*30 FMTOUT
C     ------------------------------------------------------------------
C
C1------WRITE A LABEL IF LBLSAV IS NOT 0.
      IF(LBLSAV.NE.0) WRITE(IOUT,5) KSTP,KPER,PERTIM,TOTIM,TEXT,NCOL,
     1                 NROW,ILAY,FMTOUT
5     FORMAT(2(1X,I5),1P,2(1X,E14.6),1X,A,3(1X,I6),1X,A)
cc      WRITE(*,5) KSTP,KPER,PERTIM,TOTIM,TEXT,NCOL,
cc     1                 NROW,ILAY,FMTOUT
C2------WRITE THE ARRAY USING THE SPECIFIED FORMAT.
      DO 10 IR=1,NROW
        WRITE(IOUT,FMTOUT) (BUFF(IC,IR),IC=1,NCOL)
10    CONTINUE
C
C3------RETURN
      RETURN
      END
C ======================================================================
      SUBROUTINE ULASV3(IDATA,TEXT,KSTP,KPER,PERTIM,TOTIM,NCOL,
     1                   NROW,ILAY,IOUT,FMTOUT,LBLSAV)
C
C-----VERSION 07MAY1998 ULASV3
C     ******************************************************************
C     SAVE 2-D (LAYER) INTEGER ARRAY ON DISK USING FORMATTED OUTPUT
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      CHARACTER*16 TEXT
      DIMENSION IDATA(NCOL,NROW)
      CHARACTER*30 FMTOUT
C     ------------------------------------------------------------------
C
C1------WRITE A LABEL IF LBLSAV IS NOT 0.
      IF(LBLSAV.NE.0) WRITE(IOUT,5) KSTP,KPER,PERTIM,TOTIM,TEXT,NCOL,
     1                 NROW,ILAY,FMTOUT
5     FORMAT(2(1X,I5),1P,2(1X,E14.6),1X,A,3(1X,I6),1X,A)
C
C2------WRITE THE ARRAY USING THE SPECIFIED FORMAT.
      DO 10 IR=1,NROW
        WRITE(IOUT,FMTOUT) (IDATA(IC,IR),IC=1,NCOL)
10    CONTINUE
C
C3------RETURN.
      RETURN
      END
C ======================================================================
      SUBROUTINE URWORD(LINE,ICOL,ISTART,ISTOP,NCODE,N,R,IOUT,IN)
C
C
C-----VERSION 1003 05AUG1992 URWORD
C     ******************************************************************
C     ROUTINE TO EXTRACT A WORD FROM A LINE OF TEXT, AND OPTIONALLY
C     CONVERT THE WORD TO A NUMBER.
C        ISTART AND ISTOP WILL BE RETURNED WITH THE STARTING AND
C          ENDING CHARACTER POSITIONS OF THE WORD.
C        THE LAST CHARACTER IN THE LINE IS SET TO BLANK SO THAT IF ANY
C          PROBLEMS OCCUR WITH FINDING A WORD, ISTART AND ISTOP WILL
C          POINT TO THIS BLANK CHARACTER.  THUS, A WORD WILL ALWAYS BE
C          RETURNED UNLESS THERE IS A NUMERIC CONVERSION ERROR.  BE SURE
C          THAT THE LAST CHARACTER IN LINE IS NOT AN IMPORTANT CHARACTER
C          BECAUSE IT WILL ALWAYS BE SET TO BLANK.
C        A WORD STARTS WITH THE FIRST CHARACTER THAT IS NOT A SPACE OR
C          COMMA, AND ENDS WHEN A SUBSEQUENT CHARACTER THAT IS A SPACE
C          OR COMMA.  NOTE THAT THESE PARSING RULES DO NOT TREAT TWO
C          COMMAS SEPARATED BY ONE OR MORE SPACES AS A NULL WORD.
C        FOR A WORD THAT BEGINS WITH "'", THE WORD STARTS WITH THE
C          CHARACTER AFTER THE QUOTE AND ENDS WITH THE CHARACTER
C          PRECEDING A SUBSEQUENT QUOTE.  THUS, A QUOTED WORD CAN
C          INCLUDE SPACES AND COMMAS.  THE QUOTED WORD CANNOT CONTAIN
C          A QUOTE CHARACTER.
C        IF NCODE IS 1, THE WORD IS CONVERTED TO UPPER CASE.
C        IF NCODE IS 2, THE WORD IS CONVERTED TO AN INTEGER.
C        IF NCODE IS 3, THE WORD IS CONVERTED TO A REAL NUMBER.
C        NUMBER CONVERSION ERROR IS WRITTEN TO UNIT IOUT IF IOUT IS
C          POSITIVE; ERROR IS WRITTEN TO DEFAULT OUTPUT IF IOUT IS 0;
C          NO ERROR MESSAGE IS WRITTEN IF IOUT IS NEGATIVE.
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      CHARACTER*(*) LINE
      CHARACTER*20 RW,STRING
C     ------------------------------------------------------------------
C
C1------Set last char in LINE to blank and set ISTART and ISTOP to point
C1------to this blank as a default situation when no word is found.  If
C1------starting location in LINE is out of bounds, do not look for a
C1------word.
      LINLEN=LEN(LINE)
      LINE(LINLEN:LINLEN)=' '
      ISTART=LINLEN
      ISTOP=LINLEN
      LINLEN=LINLEN-1
      IF(ICOL.LT.1 .OR. ICOL.GT.LINLEN) GO TO 100
C
C2------Find start of word, which is indicated by first character that
C2------is not a blank and not a comma.
      DO 10 I=ICOL,LINLEN
      IF(LINE(I:I).NE.' ' .AND. LINE(I:I).NE.',') GO TO 20
10    CONTINUE
      ICOL=LINLEN+1
      GO TO 100
C
C3------Found start of word.  Look for end.
C3A-----When word is quoted, only a quote can terminate it.
20    IF(LINE(I:I).EQ.'''') THEN
         I=I+1
         IF(I.LE.LINLEN) THEN
            DO 25 J=I,LINLEN
            IF(LINE(J:J).EQ.'''') GO TO 40
25          CONTINUE
         END IF
C
C3B-----When word is not quoted, space or comma will terminate.
      ELSE
         DO 30 J=I,LINLEN
         IF(LINE(J:J).EQ.' ' .OR. LINE(J:J).EQ.',') GO TO 40
30       CONTINUE
      END IF
C
C3C-----End of line without finding end of word; set end of word to
C3C-----end of line.
      J=LINLEN+1
C
C4------Found end of word; set J to point to last character in WORD and
C-------set ICOL to point to location for scanning for another word.
40    ICOL=J+1
      J=J-1
      IF(J.LT.I) GO TO 100
      ISTART=I
      ISTOP=J
C
C5------Convert word to upper case and RETURN if NCODE is 1.
      IF(NCODE.EQ.1) THEN
         IDIFF=ICHAR('a')-ICHAR('A')
         DO 50 K=ISTART,ISTOP
            IF(LINE(K:K).GE.'a' .AND. LINE(K:K).LE.'z')
     1             LINE(K:K)=CHAR(ICHAR(LINE(K:K))-IDIFF)
50       CONTINUE
         RETURN
      END IF
C
C6------Convert word to a number if requested.
100   IF(NCODE.EQ.2 .OR. NCODE.EQ.3) THEN
         RW=' '
         L=20-ISTOP+ISTART
         IF(L.LT.1) GO TO 200
         RW(L:20)=LINE(ISTART:ISTOP)
         IF(NCODE.EQ.2) READ(RW,'(I20)',ERR=200) N
         IF(NCODE.EQ.3) READ(RW,'(F20.0)',ERR=200) R
      END IF
      RETURN
C
C7------Number conversion error.
200   IF(NCODE.EQ.3) THEN
         STRING= 'A REAL NUMBER'
         L=13
      ELSE
         STRING= 'AN INTEGER'
         L=10
      END IF
C
C7A-----If output unit is negative, set last character of string to 'E'.
      IF(IOUT.LT.0) THEN
         N=0
         R=0.
         LINE(LINLEN+1:LINLEN+1)='E'
         RETURN
C
C7B-----If output unit is positive; write a message to output unit.
      ELSE IF(IOUT.GT.0) THEN
         IF(IN.GT.0) THEN
            WRITE(IOUT,201) IN,LINE(ISTART:ISTOP),STRING(1:L),LINE
         ELSE
            WRITE(IOUT,202) LINE(ISTART:ISTOP),STRING(1:L),LINE
         END IF
201      FORMAT(1X,/1X,'FILE UNIT',I4,' : ERROR CONVERTING "',A,
     1       '" TO ',A,' IN LINE:',/1X,A)
202      FORMAT(1X,/1X,'KEYBOARD INPUT : ERROR CONVERTING "',A,
     1       '" TO ',A,' IN LINE:',/1X,A)
C
C7C-----If output unit is 0; write a message to default output.
      ELSE
         IF(IN.GT.0) THEN
            WRITE(*,201) IN,LINE(ISTART:ISTOP),STRING(1:L),LINE
         ELSE
            WRITE(*,202) LINE(ISTART:ISTOP),STRING(1:L),LINE
         END IF
      END IF
C
C7D-----STOP after writing message.
      STOP
      END
C=======================================================================
      SUBROUTINE UCASE(WORDIN,WORDOUT,ICASE)
C-----VERSION 19980316 ERB
C     ******************************************************************
C     CONVERT A CHARACTER STRING TO ALL UPPER (ICASE > 0) OR ALL
C     LOWER (ICASE < 0) CASE.  IF ICASE = 0, NO CASE CONVERSION IS DONE.
C     ******************************************************************
C       SPECIFICATIONS:
C     ------------------------------------------------------------------
      CHARACTER WORDIN*(*), WORDOUT*(*)
      INTEGER ICASE, LENGNB, LENGIN, LENGOUT
C
C     DETERMINE LENGTH OF STRING VARIABLES
      LENGIN = LEN(WORDIN)
      LENGOUT = LEN(WORDOUT)
C
C     DETERMINE IF WORDOUT IS LONG ENOUGH TO CONTAIN NON-BLANK LENGTH
C     OF WORDIN
      LENGNB = NONB_LEN(WORDIN,LENGIN)
      IF (LENGNB.GT.LENGOUT) STOP 'STRING-LENGTH ERROR IN UCASE'
C
      WORDOUT = WORDIN
      IDIFF=ICHAR('a')-ICHAR('A')
      IF (ICASE.GT.0) THEN
C       CONVERT STRING TO UPPER CASE
        DO 10 K=1,LENGNB
          IF(WORDIN(K:K).GE.'a' .AND. WORDIN(K:K).LE.'z')
     1      WORDOUT(K:K)=CHAR(ICHAR(WORDIN(K:K))-IDIFF)
10      CONTINUE
C
      ELSEIF (ICASE.LT.0) THEN
C       CONVERT STRING TO LOWER CASE
        DO 20 K=1,LENGNB
          IF(WORDIN(K:K).GE.'A' .AND. WORDIN(K:K).LE.'Z')
     1      WORDOUT(K:K)=CHAR(ICHAR(WORDIN(K:K))+IDIFF)
20      CONTINUE
C
      ENDIF
C
      RETURN
      END
C=======================================================================
      INTEGER FUNCTION NONB_LEN(CHARVAR,LENGTH)
C     ******************************************************************
C     FUNCTION TO RETURN NON-BLANK LENGTH OF CONTENTS OF A CHARACTER
C     VARIABLE
C     ******************************************************************
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
C
C Variable list:
C   CHARVAR  = CHARACTER VARIABLE OF INTEREST
C   LENGTH   = DIMENSIONED LENGTH OF CHARVAR
C
      CHARACTER*(*) CHARVAR,C*1
      INTEGER LENGTH
C     ------------------------------------------------------------------
C
      C = ' '
      K = LENGTH+1
C
      DO 20 WHILE (C .EQ. ' ' .AND. K .GE. 1)
        K = K-1
        C = CHARVAR(K:K)
 20   CONTINUE
C
      NONB_LEN = K
C
      RETURN
      END

