C************* U.S. Geological Survey preliminary computer program ************
C******************************************************************************
C*************                 Zotall version 6.0                 *************
C******************************************************************************
C**                          Language: Fortran 77                            **
C**   Program must be recompiled then link (no system libraries are needed)  **
C**                The source code is available from below:                  **
C*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C*=============================================================================
C*     Author/Site,      Date,        Event
C*   --------------------------------------------------------------------------
C*   Leonard L. Orzol                                   Phone: (503) 251-3270
C*   U. S. Geological Survey - WRD                        FAX: (503) 251-3470
C*   10615 SE. Cherry Blossom Drive
C*   Portland, Oregon 97216 USA                    Internet: llorzol@usgs.gov
C*
C*=============================================================================
C*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C*
C* Disclaimer: 
C            Although this program has been used by the U.S. Geological Survey,
C            no warranty, expressed or implied, is made by the USGS as to the
C            accuracy and functioning of the program and related program
C            material nor shall the fact of distribution constitute any such
C            warranty, and no responsibility is assumed by the USGS in
C            connection therewith.
C*
C*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C*=============================================================================
C
C---VERSION 6.0 ZOTALL 23JUNE1997
C
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C .. Purpose:
C
C     Allocates space within the common array for zones of transport
C      polygon coverages and attributes.
C
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C .. Language: FORTRAN
C
C    Inputs:
C
C     OUTUNT  : FORTRAN UNIT NUMBER FOR MODTOOLS OUTPUT LSTING FILE
C     LENX    : MAXIMUM DIMENSION OF THE COMMON BLOCK ARRAY
C     MAXATB  : MAXIMUM NUMBER OF ATTRIBUTES IN PARTICLE ATTRIBUTE TABLE
C     MAXPTS  : MAXIMUM NUMBER OF PARTICLE POSITIONS
C
C   Inputs/Outputs:
C
C     ISUM    : INDEX NUMBER TO COMMON BLOCK ARRAY FOR ALLOCATION
C
C    Outputs:
C
C     LCATRB  : STARTING ARRAY INDEX FOR PARTICLE ATTRIBUTE TABLE
C
C     Program:
C
C     ISUM1   : INDEX NUMBER TO LAST COMMON BLOCK ARRAY FOR ALLOCATION
C
C-------------------------------------------------------------------------
      SUBROUTINE ZOTALL (
     I                   OUTUNT,
     I                   LENX,
     I                   MAXATB,MAXPTS,
     B                   ISUM,
     O                   LCATRB,
     E                   *)
C-----------------------------------------------------------------------
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
C
C:::::::::::::::::::::::  GLOBAL_VARIABLES  ::::::::::::::::::::::::::::
C
      INTEGER
     &        OUTUNT,
     &        LENX,
     &        MAXATB,MAXPTS,
     &        ISUM,
     &        LCATRB
C
C::::::::::::::::::::::::  PROGRAM_VARIABLES  ::::::::::::::::::::::::::
C
C     ------------------------------------------------------------------
C
CH----Print Modtools header
C
      WRITE(OUTUNT,'(10X,85(''-''))')
      WRITE(OUTUNT,'(30X,
     &               ''       ZONES OF TRANSPORT GIS OUTPUT PACKAGE'')')
      WRITE(OUTUNT,'(10X,85(''-''))')
      WRITE(OUTUNT,'(30X,
     &               ''              VERSION 6.0 23JUNE1997 '')')
      WRITE(OUTUNT,'(10X,85(''*''))')
      WRITE(OUTUNT,'(10X,85(''-''))')
      WRITE(OUTUNT,'(30X,
     &               ''                 ALLOCATION MODULE '')')
      WRITE(OUTUNT,'(10X,85(''=''))')
      WRITE(OUTUNT,'(//)')
C
C1----Calculate storage parameter NRCL
C
      ISP=MAXATB*MAXPTS
C
C2----Allocate space for arrays
C
      LCATRB=ISUM
      ISUM=ISUM+ISP
      ISUM1=ISUM-1
C
C3----Print Modtools operation parameters
C
      WRITE(OUTUNT,'(//,1H1,38X,
     &             ''COMMON BLOCK INDEX LISTING'',
     &             /10X,85(''-''))')
C
      WRITE(OUTUNT,'(10X,
     &             I8,1X,
     &             ''ELEMENTS OF COMMON BLOCK ARRAY USED OUT OF '',
     &             I8)')
     &          ISUM1,LENX
C
C4----Check amount of space used
C
      IF(ISUM1.GT.LENX) THEN
         WRITE(OUTUNT,'(//,
     &                ''    ***CELL ARRAY MUST BE DIMENSIONED '',
     &                ''LARGER*** ISUM '',I10,'' > LENX '',I10)')
     &             ISUM1,
     &             LENX
         WRITE(OUTUNT,'(//,
     &             '' Abnormal termination of Zotall_Subroutine'')')
         WRITE (*,'(//,'' Cell array must be dimensioned larger ISUM '',
     &              I10,'' > LENX '',I10)')
     &           ISUM1,
     &           LENX
         WRITE(*,'(//,
     &             '' Abnormal termination of Zotall_Subroutine'')')
         RETURN 1
      ENDIF
C
C5----Return
C
      RETURN
      END
C************* U.S. Geological Survey preliminary computer program ************
C******************************************************************************
C*************                 Zotrp1 version 6.0                 *************
C******************************************************************************
C**                          Language: Fortran 77                            **
C**   Program must be recompiled then link (no system libraries are needed)  **
C**                The source code is available from below:                  **
C*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C*=============================================================================
C*     Author/Site,      Date,        Event
C*   --------------------------------------------------------------------------
C*   Leonard L. Orzol                                   Phone: (503) 251-3270
C*   U. S. Geological Survey - WRD                        FAX: (503) 251-3470
C*   10615 SE. Cherry Blossom Drive
C*   Portland, Oregon 97216 USA                    Internet: llorzol@usgs.gov
C*
C*=============================================================================
C*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C*
C* Disclaimer: 
C            Although this program has been used by the U.S. Geological Survey,
C            no warranty, expressed or implied, is made by the USGS as to the
C            accuracy and functioning of the program and related program
C            material nor shall the fact of distribution constitute any such
C            warranty, and no responsibility is assumed by the USGS in
C            connection therewith.
C*
C*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C*=============================================================================
C
C---VERSION 6.0 ZOTRP1 09SEPTEBER2000
C
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C .. Purpose:
C
C     Combines the particle data from the time-series and endpoint files
C      into one file with a time-series format.  MODTOOLS will then
C      generate a polygon coverage of ZOTs (Zone_Of_Transport) and
C      a point coverage of the particles that were used to construct
C      the polygon coverage of ZOTs.  
C
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C .. Language: FORTRAN
C
C
C    Inputs:
C
C     OUTUNT  : FORTRAN UNIT WHERE OPERATIONAL OUTPUT AND ERRORS ARE RECORDED
C     TIMFIL  : MODPATH OUTPUT TIME-SERIES PARTICLE FILE NAME
C     TIMUNT  : FORTRAN UNIT NUMBER TO TIME-SERIES PARTICLE FILE
C     ENDFIL  : MODPATH OUTPUT ENDPOINT PARTICLE FILE NAME
C     ENDUNT  : FORTRAN UNIT NUMBER TO EINDPOINT PARTICLE FILE
C     MAXATB  : MAXIMUM DIMENSION OF THE NUMBER OF PARTICLE ATTRIBUTES
C     MAXPMR  : MAXIMUM NUMBER OF COVERAGE PARAMETERS
C     MAXPTS  : MAXIMUM DIMENSION OF THE NUMBER OF LABEL (MAXARC*MAXPTS)
C     NLAY    : NUMBER OF LAYERS IN MODEL
C     NROW    : NUMBER OF ROWS IN GRID
C     NCOL    : NUMBER OF COLUMNS IN GRID
C     COVPMR  : COVERAGE PARAMETERS ARRAY (MAXPMR)
C
C   Inputs/Outputs: None
C
C    Outputs:
C
C     PARTLE  : PARTICLE ATTRIBUTE TABLE
C
C-------------------------------------------------------------------------
      SUBROUTINE ZOTRP1 (
     I                   OUTUNT,
     I                   TIMFIL,TIMUNT,
     I                   ENDFIL,ENDUNT,
     I                   MAXATB,MAXPTS,MAXPMR,
     I                   NLAY,NROW,NCOL,
     I                   COVPMR,
     O                   PARTLE,
     E                   *)
C-----------------------------------------------------------------------
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
C
C::::::::::::::::::::::::  GLOBAL_VARIABLES  :::::::::::::::::::::::::::
C
C
      DIMENSION 
     1          COVPMR(MAXPMR),
     2          PARTLE(MAXPTS,MAXATB)
C
      CHARACTER*(*) TIMFIL,ENDFIL
C
      INTEGER OUTUNT,
     &        TIMUNT,
     &        ENDUNT
C
C
C::::::::::::::::::::::::  PROGRAM_VARIABLES  ::::::::::::::::::::::::::
C
      CHARACTER*300 BUFFER
      CHARACTER*80 COMFIL
C
      REAL 
     &     XGC,XLC,
     &     YGC,YLC,
     &     ZGC,ZLC,
     &     STRXGC,STRXLC,FINXGC,FINXLC,
     &     STRYGC,STRYLC,FINYGC,FINYLC,
     &     STRZGC,STRZLC,FINZGC,FINZLC,
     &     FINTIM,RESTIM
C
      INTEGER 
     &        COMUNT,ICOVER,MODFLG,
     &        IDPART,PARTID,TIMSTP,OLDSTP,ENDSTP,PRTSTP,
     &        COL,ROW,LAY,BUFDEX,COMPCT,BINARY,
     &        STRCOL,STRROW,STRLAY,STRIBD,STRNOD,
     &        FINCOL,FINROW,FINLAY,FINIBD,FINNOD,
     &        TOTPRT,TOTSTP,
     &        PRTCOL,PRTROW,
     &        MODSTP,IPCODE
C
      DATA COMFIL /'comtimend'/
C
      EXTERNAL OPEN_FILE,CLOSE_FILE,DELETE_FILE
C
C     ------------------------------------------------------------------
C
CH----Print Modtools header
C
      WRITE(OUTUNT,'(10X,85(''-''))')
      WRITE(OUTUNT,'(30X,
     &               ''       ZONES OF TRANSPORT GIS OUTPUT PACKAGE'')')
      WRITE(OUTUNT,'(10X,85(''-''))')
      WRITE(OUTUNT,'(30X,
     &               ''              VERSION 6.0 09SEPTEBER2000 '')')
      WRITE(OUTUNT,'(10X,85(''*''))')
      WRITE(OUTUNT,'(10X,85(''-''))')
      WRITE(OUTUNT,'(30X,
     &               ''                READ/PREPARE MODULE '')')
      WRITE(OUTUNT,'(10X,85(''=''))')
      WRITE(OUTUNT,'(//)')
C
C0----Time-series file
C
      IF(TIMUNT.LE.0) THEN    
         WRITE(*,'(
     &             ''      .No time-series file listed '',
     &             ''in MODPATH name file'')')
         WRITE(OUTUNT,'(
     &             ''      .No time-series file listed '',
     &             ''in MODPATH name file'')')
         GO TO 9999
      ENDIF
      IF(ENDUNT.LE.0) THEN    
         WRITE(*,'(
     &             ''      .No endpoint file listed '',
     &             ''in MODPATH name file'')')
         WRITE(OUTUNT,'(
     &             ''      .No endpoint file listed '',
     &             ''in MODPATH name file'')')
         WRITE(*,'(
     &             ''      ..These particle positions really should '',
     &             ''be included in the zone of transport analysis'')')
         WRITE(OUTUNT,'(
     &             ''      ..These particle positions really should '',
     &             ''be included in the zone of transport analysis'')')
         COMFIL=TIMFIL
         GO TO 408
      ENDIF
         WRITE(*,'(
     &          ''      .Combining particles from time-series file '',
     &          A,/,
     &          ''      ..with endpoint file '',
     &          A)')
     &       TIMFIL (1:INDEX(TIMFIL,' ')-1),
     &       ENDFIL (1:INDEX(ENDFIL,' ')-1)
C
C1----Set local variables
C
      COVDAN=999999999.9
      COVTOL=999999999.9
      NUMCEL=0
      MODFLG=INT(COVPMR(1))
      XYSCALE=COVPMR(3)
      ZSCALE=COVPMR(4)
      ANGLE=COVPMR(5)
      XOGRID=COVPMR(6)
      YOGRID=COVPMR(7)
      IF(COVPMR(9).LE.0.0) COVPMR(9)=1.0
      HSCALE=12.0/COVPMR(9)
      IF(COVPMR(8).LE.0.0) COVPMR(8)=1.0
      VSCALE=HSCALE*COVPMR(8)
      IVIEW=INT(COVPMR(10))
      IRWCL=INT(COVPMR(11))
      NUMARC=INT(COVPMR(14))
      MODFMT=INT(COVPMR(MAXPMR-4))
      MODFMT=MODFMT/100
      YMIN=COVPMR(MAXPMR)
      COMUNT=ENDUNT
      IF(MODFMT.LT.1) THEN    
         WRITE(*,'(7X,
     &             ''..Using standard text format'')')
         NSTAT=1
         ITALK=1
         CALL OPEN_FILE (ENDUNT,ENDFIL,NSTAT,ITALK,*9999)
      ELSEIF(MODFMT.EQ.1) THEN    
         WRITE(*,'(7X,
     &             '' Using compact text format'')')
         NSTAT=1
         ITALK=1
         CALL OPEN_FILE (ENDUNT,ENDFIL,NSTAT,ITALK,*9999)
      ELSE
         WRITE(*,'(7X,
     &             '' Using binary text format'')')
         NSTAT=-4
         ITALK=1
         CALL OPEN_FILE (-ABS(ENDUNT),ENDFIL,NSTAT,ITALK,*9999)
      ENDIF
C
C4----Read header line from endpoint file
C
      IF(MODFMT.LT.2) THEN    
         READ(ENDUNT,'(A)',ERR=9990,END=9991) BUFFER
         MODPTH=INDEX(BUFFER,'Version 3.00')
         COMPCT=INDEX(BUFFER,'(COMPACT)')
         BUFDEX=INDEX(BUFFER,'TREF=')
       IF(BUFDEX.GT.0) THEN
          BUFFER=BUFFER (BUFDEX+5:LEN(BUFFER))
          BUFDEX=INDEX(BUFFER,')')
        IF(BUFDEX.LE.0) BUFDEX=LEN(BUFFER)
          READ(BUFFER (1:BUFDEX-1),*) TREF
       ELSE
          TREF=0.0
       ENDIF
      ELSE
         READ(ENDUNT,ERR=9990,END=9991) BUFFER,TREF
         MODPTH=INDEX(BUFFER,'Version 3.00')
         BINARY=INDEX(BUFFER,'(BINARY)')
      ENDIF
C
C4C----Check format of endpoint file
C
      IF(MODFMT.EQ.0 .AND. MODPTH.LE.0) THEN    
         WRITE(*,'(''      .Format of particle records is '',
     &             ''not in MODPATH version 3.0 text format '')')
         WRITE(*,'(''      ..Using standard text format '',
     &             ''for MODPATH version 2.0 '')')
         MODFMT=9
         CALL CLOSE_FILE (ENDFIL,*9999)
         NSTAT=1
         ITALK=1
         CALL OPEN_FILE (ENDUNT,TIMFIL,NSTAT,ITALK,*9999)
      ENDIF
C
      IF(MODFMT.EQ.1 .AND. COMPCT.LE.0) THEN    
         WRITE(*,'(''      .Format of particle records is '',
     &             ''not in compact format '')')
         GO TO 9999
      ENDIF
C
      IF(MODFMT.EQ.2 .AND. BINARY.LE.0) THEN    
         WRITE(*,'(''      .Format of particle records is '',
     &             ''not in binary format '')')
         GO TO 9999
      ENDIF
C
C3----Endpoint particles
C
      NUMEND=0
      IDPART=0
  302 IF(MODFMT.LT.1) THEN
         READ(ENDUNT,*,ERR=9992,END=304)
     &             FINIBD,FINCOL,FINROW,FINLAY,
     &             FINXGC,FINYGC,FINZGC,FINZLC,
     &             FINTIM,
     &             STRXGC,STRYGC,STRZLC,
     &             STRCOL,STRROW,STRLAY,STRIBD,
     &             MODSTP,IPCODE,RESTIM
      ELSE IF(MODFMT.EQ.1) THEN
         READ(ENDUNT,*,ERR=9992,END=304)
     &             FINIBD,FINNOD,
     &             FINXGC,FINYGC,FINZLC,
     &             FINTIM,
     &             STRXGC,STRYGC,STRZLC,
     &             STRNOD,STRIBD,
     &             MODSTP,IPCODE,RESTIM
         CALL ND2IJK (
     &                STRNOD,
     &                STRROW,
     &                STRCOL,
     &                STRLAY,
     &                NROW,
     &                NCOL
     &                )
         CALL ND2IJK (
     &                FINNOD,
     &                FINROW,
     &                FINCOL,
     &                FINLAY,
     &                NROW,
     &                NCOL
     &                )
      ELSE IF(MODFMT.EQ.2) THEN
         READ(ENDUNT,ERR=9992,END=304)
     &             FINIBD,FINNOD,
     &             FINXGC,FINYGC,FINZLC,
     &             FINTIM,
     &             STRXGC,STRYGC,STRZLC,
     &             STRNOD,STRIBD,
     &             MODSTP,IPCODE,RESTIM
         CALL ND2IJK (
     &                STRNOD,
     &                STRROW,
     &                STRCOL,
     &                STRLAY,
     &                NROW,
     &                NCOL
     &                )
         CALL ND2IJK (
     &                FINNOD,
     &                FINROW,
     &                FINCOL,
     &                FINLAY,
     &                NROW,
     &                NCOL
     &                )
      ELSE
         READ(ENDUNT,*,ERR=9992,END=304)
     &             FINIBD,FINCOL,FINROW,FINLAY,
     &             FINXGC,FINYGC,FINZGC,FINZLC,
     &             FINTIM,
     &             STRXGC,STRYGC,STRZLC,
     &             STRCOL,STRROW,STRLAY,STRIBD
         MODSTP=0
         IPCODE=0
         RESTIM=0.0
      ENDIF
C
      IDPART=IDPART+1
      NUMEND=NUMEND+1
      PARTLE(IDPART,1)=IDPART
      PARTLE(IDPART,2)=-99
      PARTLE(IDPART,3)=FINCOL
      PARTLE(IDPART,4)=FINROW
      PARTLE(IDPART,5)=FINLAY
      PARTLE(IDPART,6)=FINXGC
      PARTLE(IDPART,7)=FINYGC
      PARTLE(IDPART,8)=FINZGC
      PARTLE(IDPART,9)=FINZLC
      PARTLE(IDPART,10)=FINTIM
      PARTLE(IDPART,11)=MODSTP
      GO TO 302
C
C3N---Close files
C
  304 CALL CLOSE_FILE (ENDFIL,*9999)
      WRITE(*,'(''      .Processed '',I10,
     &          '' particles from endpoint'')')
     &                                                    NUMEND
C
C4----Time-series particles
C
 402  TOTSTP=0
      NUMPRT=0
      NUMTIM=0
      OLDSTP=-99
C
C2D----Delete/create file containing combined particles
C
      NSTAT=2
      ITALK=1
      CALL DELETE_FILE (COMFIL,*9999)
      CALL OPEN_FILE (COMUNT,COMFIL,NSTAT,ITALK,*9999)
C
C4A----Determine particle time-series format
C
      IF(MODFMT.LT.1) THEN    
         WRITE(*,'(7X,
     &             ''..Using standard text format '',
     &             ''for MODPATH version 3.0 '')')
         NSTAT=1
         ITALK=1
         CALL OPEN_FILE (TIMUNT,TIMFIL,NSTAT,ITALK,*9999)
      ELSEIF(MODFMT.EQ.1) THEN    
         WRITE(*,'(7X,
     &             '' Using compact text format'')')
         NSTAT=1
         ITALK=1
         CALL OPEN_FILE (TIMUNT,TIMFIL,NSTAT,ITALK,*9999)
      ELSEIF(MODFMT.EQ.2) THEN
         WRITE(*,'(7X,
     &             '' Using binary text format'')')
         NSTAT=-4
         ITALK=1
         CALL OPEN_FILE (-ABS(TIMUNT),TIMFIL,NSTAT,ITALK,*9999)
      ELSE
         WRITE(*,'(7X,
     &             ''..Using standard text format '',
     &             ''for MODPATH version 2.0 '')')
         NSTAT=1
         ITALK=1
         CALL OPEN_FILE (TIMUNT,TIMFIL,NSTAT,ITALK,*9999)
      ENDIF
C
C4----Read header line from time-series file
C
      IF(MODFMT.LT.2) THEN    
         READ(TIMUNT,'(A)',ERR=9990,END=9991) BUFFER
         MODPTH=INDEX(BUFFER,'Version 3.00')
         COMPCT=INDEX(BUFFER,'(COMPACT)')
         BUFDEX=INDEX(BUFFER,'TREF=')
       IF(BUFDEX.GT.0) THEN
          BUFFER=BUFFER (BUFDEX+5:LEN(BUFFER))
          BUFDEX=INDEX(BUFFER,')')
        IF(BUFDEX.LE.0) BUFDEX=LEN(BUFFER)
          READ(BUFFER (1:BUFDEX-1),*) TREF
       ELSE
          TREF=0.0
       ENDIF
      ELSE
         READ(TIMUNT,ERR=9990,END=9991) BUFFER,TREF
         MODPTH=INDEX(BUFFER,'Version 3.00')
         BINARY=INDEX(BUFFER,'(BINARY)')
      ENDIF
C
C4C----Check format of time-series file
C
      IF(MODFMT.EQ.0 .AND. MODPTH.LE.0) THEN    
         WRITE(*,'(''      .Format of particle records is '',
     &             ''not in MODPATH version 3.0 text format '')')
         WRITE(*,'(''      ..Using standard text format '',
     &             ''for MODPATH version 2.0 '')')
         MODFMT=9
         CALL CLOSE_FILE (TIMFIL,*9999)
         NSTAT=1
         ITALK=1
         CALL OPEN_FILE (TIMUNT,TIMFIL,NSTAT,ITALK,*9999)
      ENDIF
C
      IF(MODFMT.EQ.1 .AND. COMPCT.LE.0) THEN    
         WRITE(*,'(''      .Format of particle records is '',
     &             ''not in compact format '')')
         GO TO 9999
      ENDIF
C
      IF(MODFMT.EQ.2 .AND. BINARY.LE.0) THEN    
         WRITE(*,'(''      .Format of particle records is '',
     &             ''not in binary format '')')
         GO TO 9999
      ENDIF
C
C4A---Loop to read points from timesers file
C
  404 IF(MODFMT.LT.1) THEN    
         READ(TIMUNT,*,ERR=9995,END=406)
     &                                  TIMSTP,
     &                                  IDPART,
     &                                  COL,
     &                                  ROW,
     &                                  LAY,
     &                                  XGC,
     &                                  YGC,
     &                                  ZGC,
     &                                  ZLC,
     &                                  TIME,
     &                                  MODSTP
      ELSE IF(MODFMT.EQ.1) THEN
         READ(TIMUNT,*,ERR=9995,END=406)
     &                                  TIMSTP,
     &                                  IDPART,
     &                                  NODE,
     &                                  XGC,
     &                                  YGC,
     &                                  ZGC,
     &                                  ZLC,
     &                                  TIME,
     &                                  MODSTP
         CALL ND2IJK (
     &                NODE,
     &                ROW,
     &                COL,
     &                LAY,
     &                NROW,
     &                NCOL
     &                )
      ELSE IF(MODFMT.EQ.2) THEN
         READ(TIMUNT,ERR=9995,END=406)
     &                                  TIMSTP,
     &                                  IDPART,
     &                                  NODE,
     &                                  XGC,
     &                                  YGC,
     &                                  ZGC,
     &                                  ZLC,
     &                                  TIME,
     &                                  MODSTP
         CALL ND2IJK (
     &                NODE,
     &                ROW,
     &                COL,
     &                LAY,
     &                NROW,
     &                NCOL
     &                )
      ELSE
         READ(TIMUNT,*,ERR=9995,END=406)
     &                                  TIMSTP,
     &                                  IDPART,
     &                                  COL,
     &                                  ROW,
     &                                  LAY,
     &                                  XGC,
     &                                  YGC,
     &                                  ZGC,
     &                                  ZLC,
     &                                  TIME
         MODSTP=0
      ENDIF
C
C4Aa----Time step = 0
C
      IF(TIMSTP.LT.1) THEN
         NUMTIM=NUMTIM+1
         NUMPRT=NUMTIM
         WRITE(COMUNT,
     &         '(I4,1X,I7,3(1X,I4),1X,E12.5,4(1X,E12.5),1X,I7)')
     &                                  TIMSTP,
     &                                  IDPART,
     &                                  COL,
     &                                  ROW,
     &                                  LAY,
     &                                  XGC,
     &                                  YGC,
     &                                  ZGC,
     &                                  ZLC,
     &                                  TIME,
     &                                  MODSTP
         GO TO 404
      ENDIF
C
C4D----Test time step index number and output ZOTs
C
      IF(OLDSTP.NE.TIMSTP) THEN
       IF(NUMPRT.LT.NUMTIM) THEN
          DO 400 I=1,NUMEND
             ENDSTP=PARTLE(I,2)
             ENDTIM=PARTLE(I,10)
           IF(ENDSTP.LT.0 .AND. ENDTIM.LT.TIME) THEN
              PARTID=PARTLE(I,1)
              PARTLE(I,2)=99
              FINCOL=PARTLE(I,3)
              FINROW=PARTLE(I,4)
              FINLAY=PARTLE(I,5)
              FINXGC=PARTLE(I,6)
              FINYGC=PARTLE(I,7)
              FINZGC=PARTLE(I,8)
              FINZLC=PARTLE(I,9)
              FINTIM=PARTLE(I,10)
              MODEND=PARTLE(I,11)
              WRITE(COMUNT,
     &              '(I4,1X,I7,3(1X,I4),1X,E12.5,
     &                4(1X,E12.5),1X,I7)')
     &                                  OLDSTP,
     &                                  PARTID,
     &                                  FINCOL,
     &                                  FINROW,
     &                                  FINLAY,
     &                                  FINXGC,
     &                                  FINYGC,
     &                                  FINZGC,
     &                                  FINZLC,
     &                                  FINTIM,
     &                                  MODEND
            ENDIF
 400      CONTINUE
       ENDIF
C
       IF(IDPART.GT.1) THEN
          DO 410 I=NUMPRT,NUMTIM
             ENDSTP=PARTLE(I,2)
           IF(ENDSTP.LT.0) THEN
              PARTID=PARTLE(I,1)
              PARTLE(I,2)=99
              FINCOL=PARTLE(I,3)
              FINROW=PARTLE(I,4)
              FINLAY=PARTLE(I,5)
              FINXGC=PARTLE(I,6)
              FINYGC=PARTLE(I,7)
              FINZGC=PARTLE(I,8)
              FINZLC=PARTLE(I,9)
              FINTIM=PARTLE(I,10)
              MODEND=PARTLE(I,11)
              WRITE(COMUNT,
     &              '(I4,1X,I7,3(1X,I4),1X,E12.5,
     &                4(1X,E12.5),1X,I7)')
     &                                  OLDSTP,
     &                                  PARTID,
     &                                  FINCOL,
     &                                  FINROW,
     &                                  FINLAY,
     &                                  FINXGC,
     &                                  FINYGC,
     &                                  FINZGC,
     &                                  FINZLC,
     &                                  FINTIM,
     &                                  MODEND
            ENDIF
 410      CONTINUE
       ENDIF
C
         NUMPRT=1
         OLDTIM=TRKTIM
         TRKTIM=TIME
         WRITE(*,'(''      .Processing time step '',I10)')
     &                                                    TIMSTP
         OLDSTP=TIMSTP
         TOTSTP=TOTSTP+1
C
         WRITE(COMUNT,
     &         '(I4,1X,I7,3(1X,I4),1X,E12.5,
     &           4(1X,E12.5),1X,I7)')
     &                                  TIMSTP,
     &                                  IDPART,
     &                                  COL,
     &                                  ROW,
     &                                  LAY,
     &                                  XGC,
     &                                  YGC,
     &                                  ZGC,
     &                                  ZLC,
     &                                  TIME,
     &                                  MODSTP
         GO TO 404
       ENDIF
C
C4Aa----Time step
C
      IF(OLDSTP.EQ.TIMSTP) THEN
         NUMPRT=NUMPRT+1
       IF(NUMPRT.LT.IDPART) THEN
          DO 420 I=NUMPRT,IDPART-1
             ENDSTP=PARTLE(I,2)
           IF(ENDSTP.LT.0) THEN
              PARTID=PARTLE(I,1)
              PARTLE(I,2)=99
              FINCOL=PARTLE(I,3)
              FINROW=PARTLE(I,4)
              FINLAY=PARTLE(I,5)
              FINXGC=PARTLE(I,6)
              FINYGC=PARTLE(I,7)
              FINZGC=PARTLE(I,8)
              FINZLC=PARTLE(I,9)
              FINTIM=PARTLE(I,10)
              MODEND=PARTLE(I,11)
              WRITE(COMUNT,
     &           '(I4,1X,I7,3(1X,I4),1X,E12.5,
     &             4(1X,E12.5),1X,I7)')
     &                                  TIMSTP,
     &                                  PARTID,
     &                                  FINCOL,
     &                                  FINROW,
     &                                  FINLAY,
     &                                  FINXGC,
     &                                  FINYGC,
     &                                  FINZGC,
     &                                  FINZLC,
     &                                  FINTIM,
     &                                  MODEND
           ENDIF
  420    CONTINUE
         NUMPRT=IDPART
       ENDIF
C
          WRITE(COMUNT,
     &          '(I4,1X,I7,3(1X,I4),1X,1PE12.5,
     &            4(1X,E12.5),1X,I7)')
     &                                  TIMSTP,
     &                                  IDPART,
     &                                  COL,
     &                                  ROW,
     &                                  LAY,
     &                                  XGC,
     &                                  YGC,
     &                                  ZGC,
     &                                  ZLC,
     &                                  TIME,
     &                                  MODSTP
      ENDIF
C
C4E----Set count particles
C
      TOTPRT=TOTPRT+1
      GO TO 404
C
C4N---Close files
C
  406 CALL CLOSE_FILE (TIMFIL,*9999)
      CALL CLOSE_FILE (COMFIL,*9999)
C
C5----Reset time-series file
C
 408  TIMFIL=COMFIL
      COVPMR(MAXPMR-4)=0
C
C6----Messages
C
C
C6A----Message to user
C
      WRITE(*,'(''      .'',I10,
     &          '' particles generating '',I5)')
     &        TOTPRT,
     &        TOTSTP
       GO TO 1000
C**********************************************************************C
C<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>C
C                        Program Errors
C<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>C
CE*********************************************************************C
 9990 WRITE(*,
     &      '(//,'' Unable to read first line from '',
     &      ''Endpoint file'')')
      WRITE(OUTUNT,
     &      '(//,'' Unable to read first line from '',
     &      ''Endpoint file'')')
      CALL CLOSE_FILE (ENDFIL,*9999)
      GO TO 9999
 9991 WRITE(*,
     &      '(//,'' Premature end-of-line error in '',
     &      ''Endpoint file'')')
      WRITE(OUTUNT,
     &      '(//,'' Premature end-of-line error in '',
     &      ''Endpoint file'')')
      GO TO 9999
 9992 WRITE(*,
     &      '(//,'' Wrong format in Endpoint file'')')
      WRITE(OUTUNT,
     &      '(//,'' Wrong format in Endpoint file'')')
      CALL CLOSE_FILE (ENDFIL,*9999)
      GO TO 9999
 9993 WRITE(*,
     &      '(//,'' Unable to read first line from '',
     &      ''Timeseries file'')')
      WRITE(OUTUNT,
     &      '(//,'' Unable to read first line from '',
     &      ''Timeseries file'')')
      CALL CLOSE_FILE (TIMFIL,*9999)
      GO TO 9999
 9994 WRITE(*,
     &      '(//,'' Premature end-of-line error in '',
     &      ''Timeseries file'')')
      WRITE(OUTUNT,
     &      '(//,'' Premature end-of-line error in '',
     &      ''Timeseries file'')')
      GO TO 9999
 9995 WRITE(*,
     &      '(//,'' Wrong format in Timeseries file'')')
      WRITE(OUTUNT,
     &      '(//,'' Wrong format in Timeseries file'')')
      CALL CLOSE_FILE (TIMFIL,*9999)
      GO TO 9999
 9999 WRITE(*,'(//,
     &          '' Abnormal termination of Zotrp1_Subroutine'')')
      RETURN 1
C**********************************************************************C
C<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>C
C                  Return to Calling Program
C<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>C
C**********************************************************************C
 1000 RETURN
      END
C************* U.S. Geological Survey preliminary computer program ************
C******************************************************************************
C*************                 Pthzot version 6.0                 *************
C******************************************************************************
C**                          Language: Fortran 77                            **
C**   Program must be recompiled then link (no system libraries are needed)  **
C**                The source code is available from below:                  **
C*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C*=============================================================================
C*     Author/Site,      Date,        Event
C*   --------------------------------------------------------------------------
C*   Leonard L. Orzol                                   Phone: (503) 251-3270
C*   U. S. Geological Survey - WRD                        FAX: (503) 251-3470
C*   10615 SE. Cherry Blossom Drive
C*   Portland, Oregon 97216 USA                    Internet: llorzol@usgs.gov
C*
C*=============================================================================
C*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C*
C* Disclaimer: 
C            Although this program has been used by the U.S. Geological Survey,
C            no warranty, expressed or implied, is made by the USGS as to the
C            accuracy and functioning of the program and related program
C            material nor shall the fact of distribution constitute any such
C            warranty, and no responsibility is assumed by the USGS in
C            connection therewith.
C*
C*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C*=============================================================================
C
C---VERSION 6.0 PTHZOT 26MARCH2002
C
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C .. Purpose:
C
C     Generates a polygon coverage of ZOTs (Zone_Of_Transport) and
C      a point coverage of the particles that were used to construct
C      the polygon coverage of ZOTs.  This program uses the
C      results of the particle-tracking program MODPATH using the 
C      time-series option; running MODPATH in the backward mode; and 
C      the MODPATH output file TIMESERS.  The zero time_step defines the
C      starting zone of transport for a single cell or a number of
C      continuously connected cells.
C       The results from modular model (McDonald and Harbaugh, 1988) that 
C      are used by the particle tracker model (Pollock, 1989) are 
C      accurate only to the cell.  
C       Therefore, starting particles should only be positioned on the faces
C      of the cell(s).  This program differentiates starting particles 
C      within one cell or cells by their row, column, and layer.  Then the
C      program uses an algorithm that divides the grid using the center
C      of the starting cells into circular sections like the operation
C      of a clock.  The center of the starting cells is calculated and
C      represents the center of the clock.  The hands of the clock sweep
C      along equal arcs.  The length of each arc is determined by the
C      user with the following formula: number of arcs = 360 divided by
C      the number of arcs specified by the user.  Particles are selected
C      by time step first then their distance from the center of the
C      staring cells.  As the hands of the clock rotate through an equal
C      arc, a pie-shaped area, sector, is defined.  The radius for each 
C      particle within a sector is determined and compared.  The particle
C      with the longest radius is selected.  A representative point for
C      all particles within a sector is calculated using the longest radius
C      and the bisector of a sector.
C       The user will find that constructing zones of transport requires
C      a "trail and error" approach.  The number of starting particles used
C      and the number of equal arcs are dependent on each other.  Generally,
C      the best approach is place a high number of particles on cell faces.
C      A good number would be 100 particles per face, and then experiment
C      with the number of arcs.  The user should place particles on all
C      horizontal faces and bottom face when trying to construct mapview
C      perspective.  The user should place particles on all faces when 
C      trying to construct vertical perspective.
C
C      Note:  The user should know the particle data output in the
C       TIMSERS file represents only those particle for each user specified
C       time step.  The user may want to include particle data from the
C       ENDPOINT file to complete the zones of transport.
C
C      Warning: The zones of transport constructed for the mapview perspective
C       can be different than the zones of transport constructed for the
C       vertical perspective for the same starting cells.  The selected
C       particles are chosen the greatest distance from the center of
C       the starting cells in the x-y plane (mapview) and the x-z or y-z
C       plane (vertical).
C
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C .. Language: FORTRAN
C
C
C    Inputs:
C
C     OUTUNT  : FORTRAN UNIT WHERE OPERATIONAL OUTPUT AND ERRORS ARE RECORDED
C     TIMFIL  : MODPATH OUTPUT TIME-SERIES PARTICLE FILE NAME
C     TIMUNT  : FORTRAN UNIT NUMBER TO TIME-SERIES PARTICLE FILE
C     ZOTCOV  : USER DEFINED ZONES OF TRANSPORT COVERAGE NAME
C     MAXATB  : MAXIMUM DIMENSION OF THE NUMBER OF PARTICLE ATTRIBUTES
C     MAXPMR  : MAXIMUM NUMBER OF COVERAGE PARAMETERS
C     MAXPTS  : MAXIMUM DIMENSION OF THE NUMBER OF LABEL (MAXARC*MAXPTS)
C     NLAY    : NUMBER OF LAYERS IN MODEL
C     NROW    : NUMBER OF ROWS IN GRID
C     NCOL    : NUMBER OF COLUMNS IN GRID
C     DELX    : ARRAY FOR CELL WIDTHS IN ROW/COLUMN/PARTICLE DIRECTION
C     COVPMR  : COVERAGE PARAMETERS ARRAY (MAXPMR)
C     IBOUND  : ARRAY FOR IBOUND ARRAY
C     LAYCBD  : ARRAY FOR CONFINING LAYERS TYPE
C     ZTOP    : ARRAY FOR LAYER/UNIT TOP ELEVATIONS 
C     ZBOT    : ARRAY FOR LAYER/UNIT BOTTOM ELEVATIONS 
C     ZCON    : ARRAY FOR CONFINING LAYER THICKNESS 
C
C   Inputs/Outputs: None
C
C    Outputs:
C
C     PARTLE  : PARTICLE ATTRIBUTE TABLE
C
C-------------------------------------------------------------------------
      SUBROUTINE PTHZOT (
     I                   OUTUNT,
     I                   TIMFIL,TIMUNT,
     I                   ZOTCOV,
     I                   MAXATB,MAXPMR,MAXPTS,
     I                   NLAY,NROW,NCOL,
     I                   DELX,COVPMR,
     I                   LRWCL,IBOUND,LAYCBD, 
     I                   ZTOP,ZBOT,ZCON, 
     O                   PARTLE,
     E                   *)
C-----------------------------------------------------------------------
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
C
C::::::::::::::::::::::::  GLOBAL_VARIABLES  :::::::::::::::::::::::::::
C
C
      DIMENSION 
     1          COVPMR(MAXPMR),
     1          LAYCBD(NLAY), 
     1          DELX(NCOL*NROW),
     2          PARTLE(MAXPTS,MAXATB),
     3          IBOUND(NCOL,NROW,NLAY),
     3          ZTOP(NCOL,NROW,NLAY), 
     3          ZBOT(NCOL,NROW,NLAY),
     3          ZCON(NCOL,NROW,NLAY) 
C
      CHARACTER*(*) ZOTCOV,TIMFIL
C
      INTEGER OUTUNT,
     &        TIMUNT
C
C
C::::::::::::::::::::::::  PROGRAM_VARIABLES  ::::::::::::::::::::::::::
C
      PARAMETER (MAXFIL=8,
     &           MAXITM=61,
     &           MXITEM=2,
     &           MAXDEG=3600+3)
C
      DIMENSION 
     &          WELRAD(MAXDEG),
     &          WELDEG(MAXDEG),
     &          XSPLIN(MAXDEG),
     &          YSPLIN(MAXDEG),
     &          LABRAD(MAXDEG),
     &          LABATR(MAXDEG),
     &          XCOORDS(MAXDEG),
     &          YCOORDS(MAXDEG)
C
      CHARACTER*300 BUFFER
      CHARACTER*128 LABFIL,TIMCOV,TMPCOV
      CHARACTER*80 FILES(MAXFIL),ADDFIL,INPFIL,TMPFIL
      CHARACTER*16 COVTYP,ITEM,ITEMS(MAXITM),ARCCMD,STRITM,RELITM,JONTYP
      CHARACTER*1 TYPITM,TYPES(MAXITM)
C
      REAL 
     &     XGC,XLC,
     &     YGC,YLC,
     &     ZGC,ZLC,
     &     XGCNTR,YGCNTR,
     &     XCOORD,YCOORD,
     &     XCOORD1,YCOORD1,
     &     TIME
C
      REAL 
     &      PRTDEG,LABDAN,PRTRAD,RADDEG,RADIUS,
     &      XLABEL,XRADUS,
     &      YLABEL,YRADUS
C
      INTEGER DECIML,DECIMLS(MAXITM),IOUT(MAXFIL),
     &        LAYER,NCOORD,OUTPUT,OUTPUTS(MAXITM),WIDTH,WIDTHS(MAXITM)
C
      INTEGER ICOVER,MODFLG,BUFDEX,
     &        IDPART,TIMSTP,OLDSTP,PRTSTP,
     &        ITMSTR(MXITEM),ITMFIN(MXITEM),
     &        COL,ROW,LAY,MODSTP,
     &        STRCOL,STRROW,STRLAY,STRIBD,STRDEL,STRCLL,
     &        PRECOL,PREROW,PRELAY,PREIBD,PRESTP,
     &        FINCOL,FINROW,FINLAY,FINIBD,FINDEL,FINCLL,
     &        TOTPRT,NUMCEL,TOTSTP,
     &        PRTCOL,PRTROW
C
      LOGICAL LAB
C
      EXTERNAL OPEN_FILE,CLOSE_FILE,DELETE_FILE
C
      DATA FILES /
     &            'timitems',
     &            'zotitems',
     &            'timatr',
     &            'zotatr',
     &            'timpnts',
     &            'zotpnts',
     &            'zotarcs',
     &            'arccmd'/
      DATA IOUT /92,93,92,93,94,95,96,97/
C
      DATA ITMSTR /1,60/
      DATA ITMFIN /59,61/
C
      DATA ITEMS /'PARTID','TIMSTP',
     &            'STRROW','STRCOL','STRLAY','STRIBD',
     &            'STRXGC','STRXLC',
     &            'STRYGC','STRYLC',
     &            'STRZGC','STRZLC',
     &            'STRTIM',
     &            'LSTROW','LSTCOL','LSTLAY','LSTIBD',
     &            'LSTXGC','LSTXLC',
     &            'LSTYGC','LSTYLC',
     &            'LSTZGC','LSTZLC',
     &            'LSTTIM',
     &            'PREROW','PRECOL','PRELAY','PREIBD',
     &            'PREXGC','PREXLC',
     &            'PREYGC','PREYLC',
     &            'PREZGC','PREZLC',
     &            'PRETIM',
     &            'PRETRV','PREXVL','PREYVL','PREZVL','PRESPD',
     &            'FINROW','FINCOL','FINLAY','FINIBD',
     &            'FINXGC','FINXLC',
     &            'FINYGC','FINYLC',
     &            'FINZGC','FINZLC',
     &            'FINTIM',
     &            'FINXVL','FINYVL','FINZVL','FINSPD',
     &            'CUMXVL','CUMYVL','CUMZVL','CUMSPD',
     &            'COV-ID','TIMSTP'/
      DATA DECIMLS / 6*0,  7*3,  4*0,  7*3,  4*0,  8*3,  4*8,  4*0,
     &                8*3,  7*8,  0,  0/
      DATA TYPES   / 6*'I',7*'F',4*'I',7*'F',4*'I',8*'F',4*'F',4*'I',
     &                8*'F',7*'F','B','I'/
      DATA WIDTHS  / 6*10, 7*8,  4*10, 7*8,  4*10, 8*8,  4*8,  4*10,
     &                8*8,  7*8, 4,  10/
      DATA OUTPUTS / 6*10, 7*16, 4*10, 7*16, 4*10, 8*16, 4*16, 4*10,
     &                8*16, 7*16,5,  10/
C
      INTRINSIC ASIN,DASIN,SIN,COS
C
C     ------------------------------------------------------------------
C
CH----Print Modtools header
C
      WRITE(OUTUNT,'(10X,85(''-''))')
      WRITE(OUTUNT,'(30X,
     &               ''       ZONES OF TRANSPORT GIS OUTPUT PACKAGE'')')
      WRITE(OUTUNT,'(10X,85(''-''))')
      WRITE(OUTUNT,'(30X,
     &               ''              VERSION 6.0 26MARCH2002 '')')
      WRITE(OUTUNT,'(10X,85(''*''))')
      WRITE(OUTUNT,'(10X,85(''-''))')
      WRITE(OUTUNT,'(30X,
     &               ''                 GIS OUTPUT MODULE '')')
      WRITE(OUTUNT,'(10X,85(''=''))')
      WRITE(OUTUNT,'(//)')
C
C0----Time-series file
C
      IF(TIMUNT.LE.0) THEN    
         WRITE(*,'(
     &             ''      .No time-series file listed '',
     &             ''in MODPATH name file'')')
         WRITE(OUTUNT,'(
     &             ''      .No time-series file listed '',
     &             ''in MODPATH name file'')')
         GO TO 9999
      ELSE
         WRITE(*,'(
     &          ''      .Processing polygons for zones of transport '',
     &          ''coverage'')')
         WRITE(*,'(
     &          ''      .Processing particles from Time-Series file '',
     &          A,'' on unit number'',I5)')
     &       TIMFIL (1:INDEX(TIMFIL,' ')-1),
     &       TIMUNT
         WRITE(OUTUNT,'(
     &          ''      .Processing particles from Time-Series file '',
     &          A,'' on unit number'',I5)')
     &       TIMFIL (1:INDEX(TIMFIL,' ')-1),
     &       TIMUNT
      ENDIF
C
C1----Set local variables
C
      TMPCOV='tmp'
      COVDAN=999999999.9
      COVTOL=999999999.9
      NUMCEL=0
      MODFLG=INT(COVPMR(1))
      XYSCALE=COVPMR(3)
      ZSCALE=COVPMR(4)
      ANGLE=COVPMR(5)
      XOGRID=COVPMR(6)
      YOGRID=COVPMR(7)
      IF(COVPMR(9).LE.0.0) COVPMR(9)=1.0
      HSCALE=12.0/COVPMR(9)
      IF(COVPMR(8).LE.0.0) COVPMR(8)=1.0
      VSCALE=HSCALE*COVPMR(8)
      IVIEW=INT(COVPMR(10))
      IRWCL=INT(COVPMR(11))
      NUMARC=INT(COVPMR(14))
      MODFMT=INT(COVPMR(MAXPMR-4))
      MODFMT=MODFMT/100
      CLLMIN=COVPMR(MAXPMR)
C
C1----Set local variables
C
C
 102  IF(NUMARC.LT.1) THEN
        WRITE(*,*) 'Enter the number of equal arcs to search in'
        READ(*,'(I10)',ERR=102) NUMARC
      ENDIF
C
      IF(NUMARC.LT.2) THEN
         WRITE(*,*) 'Must specify two or more equal arcs ',NUMARC
         NUMARC=0
         GO TO 102
      ENDIF
C
      IF(NUMARC.GT.MAXDEG) THEN
         WRITE(*,*) 'Exceed maximum number of equal arcs ',MAXDEG
         NUMARC=0
         GO TO 102
      ENDIF
C
        RADDEG=360.0/FLOAT(NUMARC)
        RADMAX=-999999.99
        DO 100 NUMRAD=1,NUMARC
           WELRAD(NUMRAD)=-9999999999.99
           LABRAD(NUMRAD)=-99
           WELDEG(NUMRAD)=FLOAT(NUMRAD)
  100   CONTINUE
C
C2----Transform from Modpath origin (lower left) to Modular Model
C      origin (upper left)
C
      YORIGN=0.0
C
C2A----Calculate upper left corner distance from DELC array (y-axis)
C
      DO 200 NUMROW=NCOL+1,NCOL+NROW
         YORIGN=YORIGN+DELX(NUMROW)
  200 CONTINUE
C
C2B----Calculate rowcol attribute definition
C
      IF(NROW.LT.10) THEN
         LENROW=1
      ELSE IF(NROW.GT.9 .AND. NROW.LT.100) THEN
         LENROW=2
      ELSE IF(NROW.GT.99 .AND. NROW.LT.1000) THEN
         LENROW=3
      ELSE
         LENROW=4
      ENDIF
C
      IF(NCOL.LT.10) THEN
         LENCOL=1
      ELSE IF(NCOL.GT.9 .AND. NCOL.LT.100) THEN
         LENCOL=2
      ELSE IF(NCOL.GT.99 .AND. NCOL.LT.1000) THEN
         LENCOL=3
      ELSE
         LENCOL=4
      ENDIF
C
      IF(NLAY.LT.10) THEN
         LENLAY=1
      ELSE IF(NLAY.GT.9 .AND. NLAY.LT.100) THEN
         LENLAY=2
      ELSE IF(NLAY.GT.99 .AND. NLAY.LT.1000) THEN
         LENLAY=3
      ELSE
         LENLAY=4
      ENDIF
C
      WIDTHS(3)=LENROW
      OUTPUTS(3)=LENROW
      WIDTHS(4)=LENCOL
      OUTPUTS(4)=LENCOL
      WIDTHS(5)=LENLAY
      OUTPUTS(5)=LENLAY
C
      WIDTHS(14)=LENROW
      OUTPUTS(14)=LENROW
      WIDTHS(15)=LENCOL
      OUTPUTS(15)=LENCOL
      WIDTHS(16)=LENLAY
      OUTPUTS(16)=LENLAY
C
      WIDTHS(25)=LENROW
      OUTPUTS(25)=LENROW
      WIDTHS(26)=LENCOL
      OUTPUTS(26)=LENCOL
      WIDTHS(27)=LENLAY
      OUTPUTS(27)=LENLAY
C
      WIDTHS(41)=LENROW
      OUTPUTS(41)=LENROW
      WIDTHS(42)=LENCOL
      OUTPUTS(42)=LENCOL
      WIDTHS(43)=LENLAY
      OUTPUTS(43)=LENLAY
C
C3----Delete and create files for attribute definitions, attribute value, and
C     coverage point data and tolerance/dangle values
C
      NSTAT=2
      ITALK=1
C
C3A----Delete/create files containing Arc/Info item definitions for
C      attribute files
C
      DO 300 N=1,MXITEM
         CALL DELETE_FILE (FILES(N),*9999)
         CALL OPEN_FILE (IOUT(N),FILES(N),NSTAT,ITALK,*9999)
  300 CONTINUE
C
C3B----Write attribute definitions
C
      ITEMS(1)=ZOTCOV (1:INDEX(ZOTCOV,' ')-1)//'-id'
      ITEMS(60)=ZOTCOV (1:INDEX(ZOTCOV,' ')-1)//'-id'
      DO 310 N=1,MXITEM
         DO 320 K=ITMSTR(N),ITMFIN(N)
            DECIML=DECIMLS(K)
            ITEM=ITEMS(K)
            OUTPUT=OUTPUTS(K)
            TYPITM=TYPES(K)
            WIDTH=WIDTHS(K)
            WRITE(IOUT(N),'(A'','',I2,'','',I2,'','',A1,'','',
     &                      I2,'',,,,,,,,,,'')')
     &                                      ITEM (1:INDEX(ITEM,' ')-1),
     &                                       WIDTH,
     &                                       OUTPUT,
     &                                       TYPITM,
     &                                       DECIML
  320    CONTINUE
  310 CONTINUE
C
C3C----Close attribute definition files
C
      DO 330 N=1,MXITEM
         CALL CLOSE_FILE (FILES(N),*9999)
 330  CONTINUE
C
C3D----Delete/create files containing Arc/Info attribute 
C
      DO 340 N=MXITEM+1,MAXFIL-1
         CALL DELETE_FILE (FILES(N),*9999)
         CALL OPEN_FILE (IOUT(N),FILES(N),NSTAT,ITALK,*9999)
  340 CONTINUE
C
C4----Center of zones of transport
C
      LABCOL=-99
      LABROW=-99
      LABLAY=-99
      LABCTR=-99
      TOTSTP=0
      NUMPRT=0
      NUMCEL=0
      OLDSTP=-99
      NUMQRT=0
C
C4A----Determine particle time-series format
C
 402  IF(MODFMT.LT.1) THEN    
         WRITE(*,'(7X,
     &             ''..Using standard text format'')')
         NSTAT=1
         ITALK=1
         CALL OPEN_FILE (TIMUNT,TIMFIL,NSTAT,ITALK,*9999)
      ELSEIF(MODFMT.EQ.1) THEN    
         WRITE(*,'(7X,
     &             '' Using compact text format'')')
         NSTAT=1
         ITALK=1
         CALL OPEN_FILE (TIMUNT,TIMFIL,NSTAT,ITALK,*9999)
      ELSE
         WRITE(*,'(7X,
     &             '' Using binary text format'')')
         NSTAT=-4
         ITALK=1
         CALL OPEN_FILE (-ABS(TIMUNT),TIMFIL,NSTAT,ITALK,*9999)
      ENDIF
C
C4----Read header line from endpoint file
C
      IF(MODFMT.LT.2) THEN    
         READ(TIMUNT,'(A)',ERR=9990,END=9991) BUFFER
         BUFDEX=INDEX(BUFFER,'TREF=')
       IF(BUFDEX.GT.0) THEN
          BUFFER=BUFFER (BUFDEX+5:LEN(BUFFER))
          BUFDEX=INDEX(BUFFER,')')
        IF(BUFDEX.LE.0) BUFDEX=LEN(BUFFER)
          READ(BUFFER (1:BUFDEX-1),*) TREF
       ELSE
          TREF=0.0
       ENDIF
      ELSE
         READ(TIMUNT,ERR=9990,END=9991) BUFFER
      ENDIF
C
C4A---Loop to read arcs from pathline file
C
 404  IF(MODFMT.LT.1) THEN    
         READ(TIMUNT,*,ERR=9992,END=502)
     &                                  TIMSTP,
     &                                  IDPART,
     &                                  COL,
     &                                  ROW,
     &                                  LAY,
     &                                  XGC,
     &                                  YGC,
     &                                  ZGC,
     &                                  ZLC,
     &                                  TIME,
     &                                  MODSTP
      ELSEIF (MODFMT.EQ.1) THEN
         READ(TIMUNT,*,ERR=9992,END=502)
     &                                  TIMSTP,
     &                                  IDPART,
     &                                  NODE,
     &                                  XGC,
     &                                  YGC,
     &                                  ZGC,
     &                                  ZLC,
     &                                  TIME,
     &                                  MODSTP
         CALL ND2IJK (
     &                NODE,
     &                ROW,
     &                COL,
     &                LAY,
     &                NROW,
     &                NCOL
     &                )
      ELSE
         READ(TIMUNT,ERR=9992,END=502)
     &                                  TIMSTP,
     &                                  IDPART,
     &                                  NODE,
     &                                  XGC,
     &                                  YGC,
     &                                  ZGC,
     &                                  ZLC,
     &                                  TIME,
     &                                  MODSTP
         CALL ND2IJK (
     &                NODE,
     &                ROW,
     &                COL,
     &                LAY,
     &                NROW,
     &                NCOL
     &                )
      ENDIF
C
C4Ab----Check time step
C
      IF(TIMSTP.LT.0) GO TO 404
C
C4Ab----Compute local x-,y-coordinates
C
     
         CALL LOCAL_COORDINATES (
     I                           NCOL,NROW,
     I                           DELX,
     I                           COL,ROW,
     I                           XGC,YGC,YORIGN,
     O                           XLC,YLC)
C
C4Ac----Compute global x-,y,z--coordinates
C
         XGC=XGC*XYSCALE
         YGC=YGC*XYSCALE
         ZGC=ZGC*ZSCALE
       IF(IVIEW.LE.0) THEN
          YGC=YGC-YORIGN*XYSCALE
        IF(ANGLE.NE.0.0) THEN
           CALL ROTATE (
     I                  ANGLE,
     B                  XGC,YGC)
        ENDIF
          XGC=XGC+XOGRID
          YGC=YGC+YOGRID
       ELSE
          XGC=XGC*HSCALE
          YGC=YGC*HSCALE
          ZGC=ZBOT(COL,ROW,LAY)+
     &        (ZTOP(COL,ROW,LAY)-ZBOT(COL,ROW,LAY))*ZLC
          ZGC=ZGC*VSCALE-CLLMIN
       ENDIF
C
C4Ad----Assign local cell center coordinates
C 
      IF(TIMSTP.LT.1 .AND. LABCTR.LE.0) THEN
         NUMPRT=NUMPRT+1
       IF(COL.NE.LABCOL .AND. ROW.NE.LABROW) THEN
          NUMCEL=NUMCEL+1
          LABCOL=COL
          LABROW=ROW
          LABLAY=LAY
          MINCOL=COL
          MAXCOL=COL
          MINROW=ROW
          MAXROW=ROW
          MINLAY=LAY
          MAXLAY=LAY
       ENDIF
C
       IF(COL.NE.LABCOL) THEN
          NUMCEL=NUMCEL+1
          LABCOL=COL
        IF(COL.GT.MAXCOL) MAXCOL=COL
        IF(COL.LT.MINCOL) MINCOL=COL
       ENDIF
C
       IF(ROW.NE.LABROW) THEN
          NUMCEL=NUMCEL+1
          LABROW=COL
        IF(ROW.GT.MAXROW) MAXROW=ROW
        IF(ROW.LT.MINROW) MINROW=ROW
       ENDIF
C
       IF(LAY.NE.LABLAY) THEN
          NUMCEL=NUMCEL+1
          LABLAY=LAY
        IF(LAY.GT.MAXLAY) MAXLAY=LAY
        IF(LAY.LT.MINLAY) MINLAY=LAY
       ENDIF
C
C4Ae----Assign global cell center coordinates
C
       IF(NUMPRT.LE.1) THEN
          XCTRMAX=XGC
          XCTRMIN=XGC
          YCTRMAX=YGC
          YCTRMIN=YGC
          ZCTRMAX=ZGC
          ZCTRMIN=ZGC
       ELSE
        IF(XGC.GT.XCTRMAX) XCTRMAX=XGC
        IF(XGC.LT.XCTRMIN) XCTRMIN=XGC
        IF(YGC.GT.YCTRMAX) YCTRMAX=YGC
        IF(YGC.LT.YCTRMIN) YCTRMIN=YGC
        IF(ZGC.GT.ZCTRMAX) ZCTRMAX=ZGC
        IF(ZGC.LT.ZCTRMIN) ZCTRMIN=ZGC
       ENDIF
        GO TO 404
      ENDIF
C
C4Af---Compute global and local cell center coordinates
C
      IF(TIMSTP.EQ.1 .AND. LABCTR.LT.0) THEN
         LABCTR=99
         XGCNTR=(XCTRMAX+XCTRMIN)/2.0
         YGCNTR=(YCTRMAX+YCTRMIN)/2.0
         ZGCNTR=(ZCTRMAX+ZCTRMIN)/2.0
C
         XLCNTR=FLOAT(MAXCOL+MINCOL-1)/2.0
         YLCNTR=FLOAT(MAXROW+MINROW-1)/2.0
         ZLCNTR=FLOAT(NLAY)-FLOAT(MAXLAY+MINLAY)/2.0+0.5
C
C4Ae---Record cell center coordinates
C
         WRITE(OUTUNT,'(/5X,96(''-''),/30X,
     &                  '' CENTER COORDINATES OF'',
     &                  '' FOR ZONES OF TRANSPORT '')')
       IF(IVIEW.LE.0) THEN
          COVPMR(MAXPMR)=XCTRMIN
          COVPMR(MAXPMR-1)=XCTRMAX
          COVPMR(MAXPMR-2)=YCTRMIN
          COVPMR(MAXPMR-3)=YCTRMAX
          WRITE(OUTUNT,'(5X,96(''-''),/5X,
     &                  '' NUMBER OF'',1X,
     &                  ''         GLOBAL'',1X,
     &                  ''         GLOBAL'',1X,
     &                  ''          LOCAL'',1X,
     &                  ''          LOCAL'',1X,
     &                  '' NUMBER OF'',1X,
     &                  /5X,
     &                  ''     CELLS'',1X,
     &                  ''   X_COORDINATE'',1X,
     &                  ''   Y_COORDINATE'',1X,
     &                  ''   X_COORDINATE'',1X,
     &                  ''   Y_COORDINATE'',1X,
     &                  ''      PARTICLES'',1X,
     &                  /,5X,96(''-''))')
          WRITE(OUTUNT,'(5X,I10,1X,4(F15.3,1X),I15)')
     &               NUMCEL,
     &               XGCNTR,YGCNTR,
     &               XLCNTR,YLCNTR,
     &               NUMPRT
       ELSE IF(IVIEW.EQ.1) THEN
          COVPMR(MAXPMR)=XCTRMIN
          COVPMR(MAXPMR-1)=XCTRMAX
          COVPMR(MAXPMR-2)=ZCTRMIN
          COVPMR(MAXPMR-3)=ZCTRMAX
          WRITE(OUTUNT,'(5X,96(''-''),/5X,
     &                  '' NUMBER OF'',1X,
     &                  ''         GLOBAL'',1X,
     &                  ''         GLOBAL'',1X,
     &                  ''          LOCAL'',1X,
     &                  ''          LOCAL'',1X,
     &                  '' NUMBER OF'',1X,
     &                  /5X,
     &                  ''     CELLS'',1X,
     &                  ''   X_COORDINATE'',1X,
     &                  ''   Z_COORDINATE'',1X,
     &                  ''   X_COORDINATE'',1X,
     &                  ''   Z_COORDINATE'',
     &                  ''      PARTICLES'',1X,
     &                  /,5X,96(''-''))')
          WRITE(OUTUNT,'(5X,I10,1X,4(F15.3,1X),I15)')
     &               NUMCEL,
     &               XGCNTR,ZGCNTR,
     &               XLCNTR,ZLCNTR,
     &               NUMPRT
       ELSE
          COVPMR(MAXPMR)=YCTRMIN
          COVPMR(MAXPMR-1)=YCTRMAX
          COVPMR(MAXPMR-2)=ZCTRMIN
          COVPMR(MAXPMR-3)=ZCTRMAX
          WRITE(OUTUNT,'(5X,96(''-''),/5X,
     &                  '' NUMBER OF'',1X,
     &                  ''         GLOBAL'',1X,
     &                  ''         GLOBAL'',1X,
     &                  ''          LOCAL'',1X,
     &                  ''          LOCAL'',1X,
     &                  '' NUMBER OF'',1X,
     &                  /5X,
     &                  ''     CELLS'',1X,
     &                  ''   Y_COORDINATE'',1X,
     &                  ''   Z_COORDINATE'',1X,
     &                  ''   Y_COORDINATE'',1X,
     &                  ''   Z_COORDINATE'',
     &                  ''      PARTICLES'',1X,
     &                  /,5X,96(''-''))')
          WRITE(OUTUNT,'(5X,I10,1X,4(F15.3,1X),I15)')
     &               NUMCEL,
     &               YGCNTR,YGCNTR,
     &               YLCNTR,ZLCNTR,
     &               NUMPRT
       ENDIF
          WRITE(OUTUNT,'(5X,96(''-''))')
          CALL CLOSE_FILE (TIMFIL,*9999)
          OLDSTP=-99
          NUMPRT=0
          GO TO 402
      ENDIF
C
C4Aa----Count particles
C
      NUMPRT=NUMPRT+1
C
C4Dd----Reset time if less than 0.000000001
C
        TIME=ABS(TIME)
      IF(TIME.LT.0.000000001) TIME=0.0
C
C4D----Test time step index number and output ZOTs
C
      IF(OLDSTP.NE.TIMSTP) THEN
C
C4Da---Write ZOT polygon arc and attributes
C
       IF(TOTSTP.GT.0) THEN
          WRITE(*,'(''      . Processed '',I10,'' particles'')')
     &            NUMPRT
         WRITE(*,'(''      . Processed '',I10,'' quadrants'')')
     &            NUMQRT
          LAB=.FALSE.
        IF(IVIEW.LE.0 .AND. NUMQRT.GT.0) THEN
           CALL OUTPUT_ZOT (
     I                     OUTUNT,
     I                     IOUT,MAXFIL,
     I                     TIMSTP,TOTSTP,OLDSTP,
     I                     MAXATB,MAXPMR,MAXPTS,MAXDEG,
     I                     NLAY,NROW,NCOL,
     I                     DELX,COVPMR,
     I                     XGCNTR,YGCNTR,
     I                     XLCNTR,YLCNTR,
     I                     WELRAD,
     I                     WELDEG,
     I                     LABRAD,
     I                     LABATR,
     I                     XCOORDS,
     I                     YCOORDS,
     O                     PARTLE
     E                    )
        ELSE IF(IVIEW.EQ.1 .AND. NUMQRT.GT.0) THEN
           CALL OUTPUT_ZOT (
     I                     OUTUNT,
     I                     IOUT,MAXFIL,
     I                     TIMSTP,TOTSTP,OLDSTP,
     I                     MAXATB,MAXPMR,MAXPTS,MAXDEG,
     I                     NLAY,NROW,NCOL,
     I                     DELX,COVPMR,
     I                     XGCNTR,ZGCNTR,
     I                     XLCNTR,ZLCNTR,
     I                     WELRAD,
     I                     WELDEG,
     I                     LABRAD,
     I                     LABATR,
     I                     XCOORDS,
     I                     YCOORDS,
     O                     PARTLE
     E                    )
        ELSE
         IF(NUMQRT.GT.0) THEN
            CALL OUTPUT_ZOT (
     I                       OUTUNT,
     I                       IOUT,MAXFIL,
     I                       TIMSTP,TOTSTP,OLDSTP,
     I                       MAXATB,MAXPMR,MAXPTS,MAXDEG,
     I                       NLAY,NROW,NCOL,
     I                       DELX,COVPMR,
     I                       YGCNTR,ZGCNTR,
     I                       YLCNTR,ZLCNTR,
     I                       WELRAD,
     I                       WELDEG,
     I                       LABRAD,
     I                       LABATR,
     I                       XCOORDS,
     I                       YCOORDS,
     O                       PARTLE
     E                      )
         ENDIF
        ENDIF
          NUMPRT=0
          NUMQRT=0
       ENDIF
C
C4Dc---Set ZOT polygon arc, label, and attributes
C
         WRITE(*,'(''      .Processing time step '',I10)')
     &                                                    TIMSTP
         OLDSTP=TIMSTP
         TOTSTP=TOTSTP+1
         WRITE(OUTUNT,'(/5X,118(''-''),/26X,
     &                  '' COORDINATES OF POLYGONS'',
     &                  '' FOR ZONES OF TRANSPORT'',
     &                  '' AT DEGREE INTERVALS OF '',
     &                  F10.3)')
     &                                                    RADDEG
       IF(IVIEW.LE.0) THEN
          WRITE(OUTUNT,'(5X,118(''-''),/5X,
     &                  '' TIME_STEP'',1X,
     &                  ''    SECTOR'',1X,
     &                  ''  PARTICLE'',1X,
     &                  ''         GLOBAL'',1X,
     &                  ''         GLOBAL'',1X,
     &                  ''          LOCAL'',1X,
     &                  ''          LOCAL'',1X,
     &                  ''    SECTOR'',1X,
     &                  ''   DEGREES'',
     &                  /38X,
     &                  ''   X_COORDINATE'',1X,
     &                  ''   Y_COORDINATE'',1X,
     &                  ''   X_COORDINATE'',1X,
     &                  ''   Y_COORDINATE'',1X,
     &                  ''    RADIUS'',
     &                  /,5X,118(''-''))')
       ELSE IF(IVIEW.EQ.1) THEN
          WRITE(OUTUNT,'(5X,118(''-''),/5X,
     &                  '' TIME_STEP'',1X,
     &                  ''    SECTOR'',1X,
     &                  ''  PARTICLE'',1X,
     &                  ''         GLOBAL'',1X,
     &                  ''         GLOBAL'',1X,
     &                  ''          LOCAL'',1X,
     &                  ''          LOCAL'',1X,
     &                  ''    SECTOR'',1X,
     &                  ''   DEGREES'',
     &                  /38X,
     &                  ''   X_COORDINATE'',1X,
     &                  ''   Z_COORDINATE'',1X,
     &                  ''   X_COORDINATE'',1X,
     &                  ''   Z_COORDINATE'',1X,
     &                  ''    RADIUS'',
     &                  /,5X,118(''-''))')
       ELSE
          WRITE(OUTUNT,'(5X,118(''-''),/5X,
     &                  '' TIME_STEP'',1X,
     &                  ''    SECTOR'',1X,
     &                  ''  PARTICLE'',1X,
     &                  ''         GLOBAL'',1X,
     &                  ''         GLOBAL'',1X,
     &                  ''          LOCAL'',1X,
     &                  ''          LOCAL'',1X,
     &                  ''    SECTOR'',1X,
     &                  ''   DEGREES'',
     &                  /38X,
     &                  ''   Y_COORDINATE'',1X,
     &                  ''   Z_COORDINATE'',1X,
     &                  ''   Y_COORDINATE'',1X,
     &                  ''   Z_COORDINATE'',1X,
     &                  ''    RADIUS'',
     &                  /,5X,118(''-''))')
       ENDIF
      ENDIF
C
C4E----Set count particles
C
        TOTPRT=TOTPRT+1
       IF(IDPART.GT.MAXPTS) GO TO 9993
C
C4H----Load particle attributes
C
        PARTLE(IDPART,1)=IDPART
        PARTLE(IDPART,2)=TIMSTP
C
C4ha----Load start attributes
C
      IF(TIMSTP.LE.0) THEN
         PARTLE(IDPART,3)=COL
         PARTLE(IDPART,4)=ROW
         PARTLE(IDPART,5)=LAY
         PARTLE(IDPART,6)=IBOUND(COL,ROW,LAY)
         PARTLE(IDPART,7)=XGC
         PARTLE(IDPART,8)=XLC
         PARTLE(IDPART,9)=YGC
         PARTLE(IDPART,10)=YLC
         PARTLE(IDPART,11)=ZGC
         PARTLE(IDPART,12)=ZLC
         PARTLE(IDPART,13)=TIME
      ENDIF
C
C4hb----Load last attributes
C
      IF(TIMSTP.LE.0) THEN
         PARTLE(IDPART,14)=COL
         PARTLE(IDPART,15)=ROW
         PARTLE(IDPART,16)=LAY
         PARTLE(IDPART,17)=IBOUND(COL,ROW,LAY)
         PARTLE(IDPART,18)=XGC
         PARTLE(IDPART,19)=XLC
         PARTLE(IDPART,20)=YGC
         PARTLE(IDPART,21)=YLC
         PARTLE(IDPART,23)=ZLC
         PARTLE(IDPART,24)=TIME
      ELSE
         PARTLE(IDPART,14)=PARTLE(IDPART,25)
         PARTLE(IDPART,15)=PARTLE(IDPART,26)
         PARTLE(IDPART,16)=PARTLE(IDPART,27)
         PARTLE(IDPART,17)=PARTLE(IDPART,28)
         PARTLE(IDPART,18)=PARTLE(IDPART,29)
         PARTLE(IDPART,19)=PARTLE(IDPART,30)
         PARTLE(IDPART,20)=PARTLE(IDPART,31)
         PARTLE(IDPART,21)=PARTLE(IDPART,32)
         PARTLE(IDPART,22)=PARTLE(IDPART,33)
         PARTLE(IDPART,23)=PARTLE(IDPART,34)
         PARTLE(IDPART,24)=PARTLE(IDPART,35)
      ENDIF
C
C4hc----Load present attributes
C
      IF(TIMSTP.LE.0) THEN
         PARTLE(IDPART,25)=COL
         PARTLE(IDPART,26)=ROW
         PARTLE(IDPART,27)=LAY
         PARTLE(IDPART,28)=IBOUND(COL,ROW,LAY)
         PARTLE(IDPART,29)=XGC
         PARTLE(IDPART,30)=XLC
         PARTLE(IDPART,31)=YGC
         PARTLE(IDPART,32)=YLC
         PARTLE(IDPART,33)=ZGC
         PARTLE(IDPART,34)=ZLC
         PARTLE(IDPART,35)=TIME
         PARTLE(IDPART,36)=0.0
         PARTLE(IDPART,37)=0.0
         PARTLE(IDPART,38)=0.0
         PARTLE(IDPART,39)=0.0
         PARTLE(IDPART,40)=0.0
      ELSE
         PARTLE(IDPART,25)=COL
         PARTLE(IDPART,26)=ROW
         PARTLE(IDPART,27)=LAY
         PARTLE(IDPART,28)=IBOUND(COL,ROW,LAY)
         PARTLE(IDPART,29)=XGC
         PARTLE(IDPART,30)=XLC
         PARTLE(IDPART,31)=YGC
         PARTLE(IDPART,32)=YLC
         PARTLE(IDPART,33)=ZGC
         PARTLE(IDPART,34)=ZLC
         PARTLE(IDPART,35)=TIME
         TRVTIM=TIME-PARTLE(IDPART,24)
         PARTLE(IDPART,36)=TRVTIM
       IF(TRVTIM.GT.0.0) THEN
          XGCVEL=(XGC-PARTLE(IDPART,18))/TRVTIM
          YGCVEL=(YGC-PARTLE(IDPART,20))/TRVTIM
          ZGCVEL=(ZGC-PARTLE(IDPART,22))/TRVTIM
          XYZSPD=(XGCVEL**2.0+YGCVEL**2.0+ZGCVEL**2.0)**0.5
        IF(XGCVEL.LE.0.0000001) XGCVEL=0.0000001
        IF(YGCVEL.LE.0.0000001) YGCVEL=0.0000001
        IF(ZGCVEL.LE.0.0000001) ZGCVEL=0.0000001
        IF(XYZSPD.LE.0.0000001) XYZSPD=0.0000001
       ELSE
          XGCVEL=0.0
          YGCVEL=0.0
          ZGCVEL=0.0
          XYZSPD=0.0
       ENDIF
          PARTLE(IDPART,37)=XGCVEL
          PARTLE(IDPART,38)=YGCVEL
          PARTLE(IDPART,39)=ZGCVEL
          PARTLE(IDPART,40)=XYZSPD
      ENDIF
C
C4hd----Load cumulative attributes
C
      IF(TIMSTP.LE.0) THEN
         PARTLE(IDPART,56)=0.0
         PARTLE(IDPART,57)=0.0
         PARTLE(IDPART,58)=0.0
         PARTLE(IDPART,59)=0.0
      ELSE
         PARTLE(IDPART,56)=PARTLE(IDPART,56)+XGCVEL
         PARTLE(IDPART,57)=PARTLE(IDPART,57)+YGCVEL
         PARTLE(IDPART,58)=PARTLE(IDPART,57)+ZGCVEL
         PARTLE(IDPART,59)=PARTLE(IDPART,57)+XYZSPD
      ENDIF
C
C4He----Load final attributes
C
        PARTLE(IDPART,41)=COL
        PARTLE(IDPART,42)=ROW
        PARTLE(IDPART,43)=LAY
        PARTLE(IDPART,44)=IBOUND(COL,ROW,LAY)
        PARTLE(IDPART,45)=XGC
        PARTLE(IDPART,46)=XLC
        PARTLE(IDPART,47)=YGC
        PARTLE(IDPART,48)=YLC
        PARTLE(IDPART,49)=ZGC
        PARTLE(IDPART,50)=ZLC
        PARTLE(IDPART,51)=TIME
      IF(TIMSTP.LE.0) THEN
         PARTLE(IDPART,52)=0.0
         PARTLE(IDPART,53)=0.0
         PARTLE(IDPART,54)=0.0
         PARTLE(IDPART,55)=0.0
      ELSE
         PARTLE(IDPART,52)=PARTLE(IDPART,52)+XGCVEL
         PARTLE(IDPART,53)=PARTLE(IDPART,53)+YGCVEL
         PARTLE(IDPART,54)=PARTLE(IDPART,54)+ZGCVEL
         PARTLE(IDPART,55)=PARTLE(IDPART,55)+XYZSPD
      ENDIF
C
C4F----Compute quadrant for local mapview particle locations
C
      IF(IVIEW.LE.0 .OR. IVIEW.GE.4) THEN
         XCOORD=XGC
         YCOORD=YGC
         XRADUS=XCOORD-XGCNTR
         YRADUS=YCOORD-YGCNTR
         PRTRAD=(XRADUS**2.0+YRADUS**2.0)**0.5
       IF(PRTRAD.LE.0.0) GO TO 404
         RADIUS=ABS(YRADUS/PRTRAD)
C
       IF(XRADUS.LT.0.0) THEN
        IF(YRADUS.GT.0.0) THEN
           PRTDEG=ASIN(RADIUS)/0.01745329
           PRTDEG=180.0+ABS(PRTDEG)
        ELSE IF(YRADUS.LT.0.0) THEN
           PRTDEG=ASIN(RADIUS)/0.01745329
           PRTDEG=180.0-ABS(PRTDEG)
        ELSE
           PRTDEG=180.0
        ENDIF
       ELSE IF(XRADUS.EQ.0.0) THEN
        IF(YRADUS.GT.0.0) THEN
           PRTDEG=270.0
        ELSE
           PRTDEG=90.0
        ENDIF
       ELSE
        IF(YRADUS.GT.0.0) THEN
           PRTDEG=ASIN(RADIUS)/0.01745329
           PRTDEG=360.0-PRTDEG
        ELSE IF(YRADUS.LT.0.0) THEN
           PRTDEG=ASIN(RADIUS)/0.01745329
        ELSE
           PRTDEG=RADDEG/2.0
        ENDIF
       ENDIF
C
C4F----Compute quadrant for local vertical particle locations
C
      ELSE
       IF(IVIEW.EQ.1) THEN
         XCOORD=XGC
         YCOORD=ZGC
         XRADUS=XCOORD-XGCNTR
         YRADUS=YCOORD-ZGCNTR
       ELSE
         XCOORD=YGC
         YCOORD=ZGC
         XRADUS=XCOORD-YGCNTR
         YRADUS=YCOORD-ZGCNTR
       ENDIF
C
         PRTRAD=(XRADUS**2.0+YRADUS**2.0)**0.5
       IF(PRTRAD.LE.0.0) GO TO 404
         RADIUS=ABS(YRADUS/PRTRAD)
C
       IF(XRADUS.LT.0.0) THEN
        IF(YRADUS.GT.0.0) THEN
           PRTDEG=ASIN(RADIUS)/0.01745329
           PRTDEG=180.0-ABS(PRTDEG)
        ELSE IF(YRADUS.LT.0.0) THEN
           PRTDEG=ASIN(RADIUS)/0.01745329
           PRTDEG=180.0+ABS(PRTDEG)
        ELSE
           PRTDEG=180.0
        ENDIF
       ELSE IF(XRADUS.EQ.0.0) THEN
        IF(YRADUS.GT.0.0) THEN
           PRTDEG=90.0
        ELSE
           PRTDEG=270.0
        ENDIF
       ELSE
        IF(YRADUS.GT.0.0) THEN
           PRTDEG=ASIN(RADIUS)/0.01745329
        ELSE IF(YRADUS.LT.0.0) THEN
           PRTDEG=ASIN(RADIUS)/0.01745329
           PRTDEG=360.0-PRTDEG
        ELSE
           PRTDEG=0.0
        ENDIF
       ENDIF
      ENDIF
C
C4I----
C
        LABQRT=INT(PRTDEG/RADDEG)+1
        DEGQRT=RADDEG*FLOAT(LABQRT)
      IF(LABQRT.LE.0) LABQRT=1           
      IF(LABQRT.GT.NUMARC) LABQRT=NUMARC
C
C4K----Test radius for maximum in that quadrant
C
      IF(PRTRAD.GT.WELRAD(LABQRT)) THEN
         NUMQRT=NUMQRT+1
         WELRAD(LABQRT)=PRTRAD
         WELDEG(LABQRT)=PRTDEG
         LABRAD(LABQRT)=TIMSTP
         LABATR(LABQRT)=IDPART
         XCOORDS(LABQRT)=XCOORD
         YCOORDS(LABQRT)=YCOORD
       IF(IVIEW.LE.0) THEN
          WRITE(OUTUNT,'(5X,3(I10,1X),4(F15.3,1X),2(F10.3,1X))')
     &                   OLDSTP,
     &                   LABQRT,
     &                   IDPART,
     &                   XGC,
     &                   YGC,
     &                   XCOORD,
     &                   YCOORD,
     &                   PRTRAD,
     &                   PRTDEG
       ELSE IF(IVIEW.EQ.1) THEN
          WRITE(OUTUNT,'(5X,3(I10,1X),4(F15.3,1X),2(F10.3,1X))')
     &                   OLDSTP,
     &                   LABQRT,
     &                   IDPART,
     &                   XGC,
     &                   ZGC,
     &                   XCOORD,
     &                   YCOORD,
     &                   PRTRAD,
     &                   PRTDEG
       ELSE
          WRITE(OUTUNT,'(5X,3(I10,1X),4(F15.3,1X),2(F10.3,1X))')
     &                   OLDSTP,
     &                   LABQRT,
     &                   IDPART,
     &                   YGC,
     &                   ZGC,
     &                   XCOORD,
     &                   YCOORD,
     &                   PRTRAD,
     &                   PRTDEG
       ENDIF
C
C4L----Setting coverage dangle and tolerance
C
       IF(PRTRAD.LT.COVDAN) COVDAN=LABDAN/10.0
      ENDIF
C
C4M----Set maximum and minimum
C
C
C4N----Read another record
C
C
      GO TO 404
C
C4N---Process last time step
C
  502 IF(NUMPRT.GT.0) THEN
         WRITE(*,'(''      . Processed '',I10,'' particles'')')
     &            NUMPRT
         WRITE(*,'(''      . Processed '',I10,'' quadrants'')')
     &            NUMQRT
       IF(IVIEW.LE.0 .AND. NUMQRT.GT.0) THEN
          CALL OUTPUT_ZOT (
     I                    OUTUNT,
     I                    IOUT,MAXFIL,
     I                    TIMSTP,TOTSTP,OLDSTP,
     I                    MAXATB,MAXPMR,MAXPTS,MAXDEG,
     I                    NLAY,NROW,NCOL,
     I                    DELX,COVPMR,
     I                    XGCNTR,YGCNTR,
     I                    XLCNTR,YLCNTR,
     I                    WELRAD,
     I                    WELDEG,
     I                    LABRAD,
     I                    LABATR,
     I                    XCOORDS,
     I                    YCOORDS,
     O                    PARTLE
     E                   )
       ELSE IF(IVIEW.EQ.1 .AND. NUMQRT.GT.0) THEN
          CALL OUTPUT_ZOT (
     I                    OUTUNT,
     I                    IOUT,MAXFIL,
     I                    TIMSTP,TOTSTP,OLDSTP,
     I                    MAXATB,MAXPMR,MAXPTS,MAXDEG,
     I                    NLAY,NROW,NCOL,
     I                    DELX,COVPMR,
     I                    XGCNTR,ZGCNTR,
     I                    XLCNTR,ZLCNTR,
     I                    WELRAD,
     I                    WELDEG,
     I                    LABRAD,
     I                    LABATR,
     I                    XCOORDS,
     I                    YCOORDS,
     O                    PARTLE
     E                   )
       ELSE
        IF(NUMQRT.GT.0) THEN
           CALL OUTPUT_ZOT (
     I                      OUTUNT,
     I                      IOUT,MAXFIL,
     I                      TIMSTP,TOTSTP,OLDSTP,
     I                      MAXATB,MAXPMR,MAXPTS,MAXDEG,
     I                      NLAY,NROW,NCOL,
     I                      DELX,COVPMR,
     I                      YGCNTR,ZGCNTR,
     I                      YLCNTR,ZLCNTR,
     I                      WELRAD,
     I                      WELDEG,
     I                      LABRAD,
     I                      LABATR,
     I                      XCOORDS,
     I                      YCOORDS,
     O                      PARTLE
     E                     )
        ENDIF
       ENDIF
      ENDIF
C
C4N---Close files
C
      CALL CLOSE_FILE (TIMFIL,*9999)
      CALL CLOSE_FILE (FILES(3),*9999)
      CALL CLOSE_FILE (FILES(4),*9999)
      WRITE(IOUT(5),'(''END'')')
      CALL CLOSE_FILE (FILES(5),*9999)
      WRITE(IOUT(6),'(''END'')')
      CALL CLOSE_FILE (FILES(6),*9999)
      WRITE(IOUT(7),'(''END'')')
      CALL CLOSE_FILE (FILES(7),*9999)

C      GO TO 700
C
C6----Shape format
C
      CALL SHAPE_ZOT (
     I                OUTUNT,
     I                IOUT,FILES,MAXFIL,
     I                MAXATB,MAXPTS,MAXDEG,
     I                XCOORDS,
     I                YCOORDS,
     O                PARTLE,
     E                *9999)
C
C7----Messages
C
C
C7A----Message to user
C
 700  continue
      WRITE(*,'(''      Zot coverage '',A,
     &          '' consists of '')')
     &        ZOTCOV (1:INDEX(ZOTCOV,' ')-1)
      WRITE(*,'(''      .'',I10,
     &          '' particles generating '',I5,
     &          '' zones of transport for '',I5,'' cells'')')
     &        TOTPRT,
     &        TOTSTP,
     &        NUMCEL
C
C7B----Message to operational output file
C
      WRITE(OUTUNT,'(''      Zot coverage '',A,
     &               '' consists of '')')
     &        ZOTCOV (1:INDEX(ZOTCOV,' ')-1)
      WRITE(OUTUNT,'(''      .'',I10,
     &               '' particles generating '',I15,
     &          '' zones of transport for '',I5,'' cells'')')
     &        TOTPRT,
     &        TOTSTP,
     &        NUMCEL
C
C8----Arc Operations to coverage and attribute files
C
      NSTAT=2
      ITALK=1
      FILES(MAXFIL)='arccmd'
      CALL OPEN_FILE (IOUT(MAXFIL),FILES(MAXFIL),NSTAT,ITALK,*9999)
C
C8A----Create coverages TMPCOV (zone-of-transport polygons)
C
      ARCCMD='create'
      WRITE(IOUT(MAXFIL),'(A,1X,A)') 
     &                             ARCCMD (1:INDEX(ARCCMD,' ')-1),
     &                             ZOTCOV (1:INDEX(ZOTCOV,' ')-1)
      ARCCMD='generate'
      INPFIL=FILES(7) (1:INDEX(FILES(7),' ')-1)
      COVTYP='polygons'
      WRITE(IOUT(MAXFIL),'(A,3(1X,A))') 
     &                             ARCCMD (1:INDEX(ARCCMD,' ')-1),
     &                             ZOTCOV (1:INDEX(TMPCOV,' ')-1),
     &                             INPFIL (1:INDEX(INPFIL,' ')-1),
     &                             COVTYP (1:INDEX(COVTYP,' ')-1)
      ARCCMD='tables'
      TMPFIL=FILES(2) (1:INDEX(FILES(2),' ')-1)
      ADDFIL=FILES(4) (1:INDEX(FILES(4),' ')-1)
      WRITE(IOUT(MAXFIL),'(A,2(1X,A))') 
     &                             ARCCMD (1:INDEX(ARCCMD,' ')-1),
     &                             TMPFIL (1:INDEX(TMPFIL,' ')-1),
     &                             ADDFIL (1:INDEX(ADDFIL,' ')-1)
      ARCCMD='clean'
      IF(COVDAN.LE.0.0) COVDAN=0.000001
      COVTOL=COVDAN
      COVTYP='poly'
      WRITE(IOUT(MAXFIL),'(A,1X,A,1X,''#'',2(1X,F20.10),1X,A)') 
     &                             ARCCMD (1:INDEX(ARCCMD,' ')-1),
     &                             ZOTCOV (1:INDEX(ZOTCOV,' ')-1),
     &                             COVDAN,
     &                             COVTOL,
     &                             COVTYP (1:INDEX(COVTYP,' ')-1)
      ARCCMD='joinitem'
      LABFIL=ZOTCOV (1:INDEX(ZOTCOV,' ')-1)//'.PAT'
      INPFIL=FILES(4) (1:INDEX(FILES(4),' ')-1)
      RELITM=ZOTCOV (1:INDEX(ZOTCOV,' ')-1)//'-id'
      STRITM=ZOTCOV (1:INDEX(ZOTCOV,' ')-1)//'-id'
      JONTYP='ordered'      
      WRITE(IOUT(MAXFIL),'(A,6(1X,A))') 
     &                             ARCCMD (1:INDEX(ARCCMD,' ')-1),
     &                             LABFIL (1:INDEX(LABFIL,' ')-1),
     &                             INPFIL (1:INDEX(INPFIL,' ')-1),
     &                             LABFIL (1:INDEX(LABFIL,' ')-1),
     &                             RELITM (1:INDEX(RELITM,' ')-1),
     &                             STRITM (1:INDEX(STRITM,' ')-1),
     &                             JONTYP (1:INDEX(JONTYP,' ')-1)
C
C8B----Create coverages TMPCOV (time-series points used for polygons)
C
      TIMCOV='tim'//ZOTCOV (1:INDEX(ZOTCOV,' ')-1)
      ARCCMD='create'
      WRITE(IOUT(MAXFIL),'(A,1X,A)') 
     &                             ARCCMD (1:INDEX(ARCCMD,' ')-1),
     &                             TIMCOV (1:INDEX(TIMCOV,' ')-1)
      ARCCMD='generate'
      COVTYP='points'
      INPFIL=FILES(5) (1:INDEX(FILES(5),' ')-1)
      WRITE(IOUT(MAXFIL),'(A,3(1X,A))') 
     &                             ARCCMD (1:INDEX(ARCCMD,' ')-1),
     &                             TIMCOV (1:INDEX(TIMCOV,' ')-1),
     &                             INPFIL (1:INDEX(INPFIL,' ')-1),
     &                             COVTYP (1:INDEX(COVTYP,' ')-1) 
      ARCCMD='tables'
      TMPFIL=FILES(1) (1:INDEX(FILES(1),' ')-1)
      ADDFIL=FILES(3) (1:INDEX(FILES(3),' ')-1)
      WRITE(IOUT(MAXFIL),'(A,2(1X,A))') 
     &                             ARCCMD (1:INDEX(ARCCMD,' ')-1),
     &                             TMPFIL (1:INDEX(TMPFIL,' ')-1),
     &                             ADDFIL (1:INDEX(ADDFIL,' ')-1)
      ARCCMD='build'
      COVTYP='point'
      WRITE(IOUT(MAXFIL),'(A,2(1X,A))') 
     &                             ARCCMD (1:INDEX(ARCCMD,' ')-1),
     &                             TIMCOV (1:INDEX(TIMCOV,' ')-1),
     &                             COVTYP (1:INDEX(COVTYP,' ')-1)
      ARCCMD='joinitem'
      LABFIL=TIMCOV (1:INDEX(TIMCOV,' ')-1)//'.PAT'
      INPFIL=FILES(3) (1:INDEX(FILES(3),' ')-1)
      RELITM='$recno'
      STRITM=TIMCOV (1:INDEX(TIMCOV,' ')-1)//'-id'
      JONTYP='link'      
      WRITE(IOUT(MAXFIL),'(A,6(1X,A))') 
     &                             ARCCMD (1:INDEX(ARCCMD,' ')-1),
     &                             LABFIL (1:INDEX(LABFIL,' ')-1),
     &                             INPFIL (1:INDEX(INPFIL,' ')-1),
     &                             LABFIL (1:INDEX(LABFIL,' ')-1),
     &                             RELITM (1:INDEX(RELITM,' ')-1),
     &                             STRITM (1:INDEX(STRITM,' ')-1),
     &                             JONTYP (1:INDEX(JONTYP,' ')-1)
      CALL CLOSE_FILE (FILES(MAXFIL),*9999)
       GO TO 1000
C**********************************************************************C
C<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>C
C                        Program Errors
C<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>C
CE*********************************************************************C
 9990 WRITE(*,
     &      '(//,'' Unable to read first line from '',
     &      ''Timeseries file'')')
      WRITE(OUTUNT,
     &      '(//,'' Unable to read first line from '',
     &      ''Timeseries file'')')
      CALL CLOSE_FILE (TIMFIL,*9999)
      GO TO 9999
 9991 WRITE(*,
     &      '(//,'' Premature end-of-line error in '',
     &      ''Timeseries file'')')
      WRITE(OUTUNT,
     &      '(//,'' Premature end-of-line error in '',
     &      ''Timeseries file'')')
      GO TO 9999
 9992 WRITE(*,
     &      '(//,'' Wrong format in Timeseries file'')')
      WRITE(OUTUNT,
     &      '(//,'' Wrong format in Timeseries file'')')
      CALL CLOSE_FILE (TIMFIL,*9999)
      GO TO 9999
 9993 WRITE(*,
     &      '(//,'' Exceed maximum number of points > '',I10)') 
     &        MAXPTS
      WRITE(OUTUNT,
     &      '(//,'' Exceed maximum number of points > '',I10)') 
     &        MAXPTS
      CALL CLOSE_FILE (TIMFIL,*9999)
 9999 WRITE(*,'(//,
     &          '' Abnormal termination of ZOT_Subroutine'')')
      RETURN 1
C**********************************************************************C
C<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>C
C                  Return to Calling Program
C<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>C
C**********************************************************************C
 1000 RETURN
      END
C**********************************************************************C
C<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>C
C                    Output_ZOT Subroutine
C<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>C
C**********************************************************************C
      SUBROUTINE OUTPUT_ZOT (
     I                       OUTUNT,
     I                       IOUT,MAXFIL,
     I                       TIMSTP,TOTSTP,OLDSTP,
     I                       MAXATB,MAXPMR,MAXPTS,MAXDEG,
     I                       NLAY,NROW,NCOL,
     I                       DELX,COVPMR,
     I                       XGCNTR,YGCNTR,
     I                       XLCNTR,YLCNTR,
     I                       WELRAD,
     I                       WELDEG,
     I                       LABRAD,
     I                       LABATR,
     I                       XCOORDS,
     I                       YCOORDS,
     O                       PARTLE
     E                      )
C-----------------------------------------------------------------------
C
C---VERSION 6.0 OUTPUT_ZOT 30OCTOBER2000
C
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C .. Purpose:
C
C     Records coordinates and attributes for the polygon coverage of
C      ZOTs (Zone_Of_Transport) and a point coverage of the particles 
C      that were used to construct the polygon coverage of ZOTs.  
C
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C .. Language: FORTRAN
C
C
C    Inputs:
C
C     DELX    : ARRAY FOR CELL WIDTHS IN ROW/COLUMN/PARTICLE DIRECTION
C     MAXATB  : MAXIMUM DIMENSION OF THE NUMBER OF ARC, POINT, OR POLYGON
C                ATTRIBUTES IN ARC/INFO FILE
C     MAXPMR  : MAXIMUM NUMBER OF COVERAGE PARAMETERS
C     MAXPTS  : MAXIMUM DIMENSION OF THE NUMBER OF LABEL
C     NCOL    : NUMBER OF COLUMNS IN GRID
C     NLAY    : NUMBER OF LAYERS IN MODEL
C     NROW    : NUMBER OF ROWS IN GRID
C     OUTUNT  : FORTRAN UNIT WHERE OPERATIONAL OUTPUT AND ERRORS ARE RECORDED
C
C   Inputs/Outputs: None
C
C    Outputs:
C
C     PARTLE  : ARC ATTRIBUTE ARRAY (MAXPTS,MAXATB)
C
C-------------------------------------------------------------------------
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
C
C::::::::::::::::::::::::  GLOBAL_VARIABLES  :::::::::::::::::::::::::::
C
C
      DIMENSION 
     1          COVPMR(MAXPMR),
     1          DELX(NCOL*NROW),
     1          WELRAD(MAXDEG),
     1          WELDEG(MAXDEG),
     1          LABRAD(MAXDEG),
     1          LABATR(MAXDEG),
     1          XCOORDS(MAXDEG),
     1          YCOORDS(MAXDEG),
     2          PARTLE(MAXPTS,MAXATB)
C
      REAL 
     &     XGCNTR,YGCNTR,
     &     XLCNTR,YLCNTR
C
      INTEGER 
     I        OUTUNT,
     I        IOUT(MAXFIL),
     I        TIMSTP,TOTSTP,OLDSTP
C
C
C::::::::::::::::::::::::  PROGRAM_VARIABLES  ::::::::::::::::::::::::::
C
      REAL 
     &     XCOORD,YCOORD,
     &     XCOORD1,YCOORD1
C
      REAL 
     &      PRTDEG,PRTRAD,RADDEG,RADIUS,
     &      XLABEL,XRADUS,
     &      YLABEL,YRADUS
C
      INTEGER 
     &        IVIEW,
     &        IDPART,
     &        STRCOL,STRROW,STRLAY,STRIBD,
     &        PRECOL,PREROW,PRELAY,PREIBD,
     &        FINCOL,FINROW,FINLAY,FINIBD,
     &        PRTSTP
C
      LOGICAL LAB
C
      INTRINSIC ASIN,DASIN,SIN,COS
C
C     ------------------------------------------------------------------
C
CH----Print Modtools header
C
      WRITE(OUTUNT,'(//)')
      WRITE(OUTUNT,'(10X,85(''-''))')
      WRITE(OUTUNT,'(30X,
     &               ''       ZONES OF TRANSPORT GIS OUTPUT PACKAGE'')')
      WRITE(OUTUNT,'(10X,85(''-''))')
      WRITE(OUTUNT,'(30X,
     &               ''              VERSION 6.0 06NOVEMBER2000 '')')
      WRITE(OUTUNT,'(10X,85(''*''))')
      WRITE(OUTUNT,'(10X,85(''-''))')
      WRITE(OUTUNT,'(30X,
     &               ''                 GIS ZOT MODULE '')')
      WRITE(OUTUNT,'(10X,85(''=''))')
      WRITE(OUTUNT,'(//)')
C
C1----Set local variables
C
      IVIEW=INT(COVPMR(10))
      NUMARC=INT(COVPMR(14))
      RADDEG=360.0/FLOAT(NUMARC)
      IF(COVPMR(9).LE.0.0) COVPMR(9)=1.0
      HSCALE=12.0/COVPMR(9)
      IF(COVPMR(8).LE.0.0) COVPMR(8)=1.0
      VSCALE=HSCALE*COVPMR(8)
      CLLMIN=COVPMR(MAXPMR)
      CLLMAX=COVPMR(MAXPMR-1)
      GRDMAX=COVPMR(MAXPMR-2)
      GRDMIN=COVPMR(MAXPMR-3)
C
      IF(IVIEW.GE.1 .AND. IVIEW.LE.3) THEN
         XGRDMN=GRDMIN
         XGRDMX=GRDMAX
         YGRDMN=0.0
         YGRDMX=CLLMAX-CLLMIN
      ENDIF
C
C2----Write header information
C
      WRITE(OUTUNT,'(/5X,96(''-''),/12X,
     &               '' COORDINATES OF POLYGONS'',
     &               '' FOR ZONES OF TRANSPORT AT TIME STEP '',
     &               I10)')
     &                                        OLDSTP
         WRITE(OUTUNT,'(5X,96(''-''),/5X,
     &               ''             MINIMUM'',2X,
     &               ''             MAXIMUM'',2X,
     &               ''             MINIMUM'',2X,
     &               ''             MAXIMUM'',/5X,
     &               ''        X COORDINATE'',2X,
     &               ''        X COORDINATE'',2X,
     &               ''        Y COORDINATE'',2X,
     &               ''        Y COORDINATE'')')
         WRITE(OUTUNT,'(5X,96(''-''),/5X,
     &                  4(F20.5,2X))')
     &               XGRDMN,
     &               XGRDMX,
     &               YGRDMN,
     &               YGRDMX
      IF(IVIEW.LE.0) THEN
         WRITE(OUTUNT,'(5X,96(''-''),/5X,
     &               '' TIME_STEP'',1X,
     &               ''    SECTOR'',1X,
     &               ''  PARTICLE'',1X,
     &               ''        X_COORDINATE'',1X,
     &               ''        Y_COORDINATE'',1X,
     &               ''       SECTOR RADIUS'',
     &               /,5X,96(''-''))')
      ELSE IF(IVIEW.EQ.1) THEN
         WRITE(OUTUNT,'(5X,96(''-''),/5X,
     &               '' TIME_STEP'',1X,
     &               ''    SECTOR'',1X,
     &               ''  PARTICLE'',1X,
     &               ''        X_COORDINATE'',1X,
     &               ''        Z_COORDINATE'',1X,
     &               ''       SECTOR RADIUS'',
     &               /,5X,96(''-''))')
      ELSE
         WRITE(OUTUNT,'(5X,96(''-''),/5X,
     &               '' TIME_STEP'',1X,
     &               ''    SECTOR'',1X,
     &               ''  PARTICLE'',1X,
     &               ''        Y_COORDINATE'',1X,
     &               ''        Z_COORDINATE'',1X,
     &               ''       SECTOR RADIUS'',
     &               /,5X,96(''-''))')
      ENDIF
C
C3----Write coordinates and attribute information
C
      RADMAX=-9999999.99
      LAB=.FALSE.
      DO 300 NUMRAD=1,NUMARC
       IF(LABRAD(NUMRAD).LE.-99) GO TO 300
         PRTRAD=WELRAD(NUMRAD)
         PRTSTP=FLOAT(LABRAD(NUMRAD))
         XLCPRT=XCOORDS(NUMRAD)
         YLCPRT=YCOORDS(NUMRAD)
         PRTDEG=FLOAT(NUMRAD-1)*RADDEG+RADDEG/2.0
         PRTDEG=PRTDEG*0.01745329
         WRITE(OUTUNT,'(5X,3(I10,1X),3(F20.3,1X))')
     &               LABRAD(NUMRAD),
     &               NUMRAD,
     &               LABATR(NUMRAD),
     &               XLCPRT,
     &               YLCPRT,
     &               PRTRAD
         XCOORD=PRTRAD*COS(PRTDEG)
         YCOORD=PRTRAD*SIN(PRTDEG)
         WRITE(OUTUNT,'(10X,
     &                  ''CELL CENTER COORDINATES     '',
     &                  2(F20.3,1X))')
     &               XGCNTR,
     &               YGCNTR
         WRITE(OUTUNT,'(10X,
     &                  ''CALCULATED VERTEX OFFSET    '',
     &                  2(F20.3,1X))')
     &               XCOORD,
     &               YCOORD
         IDPART=LABATR(NUMRAD)
         PRECOL=PARTLE(IDPART,25)
         PREROW=PARTLE(IDPART,26)
C
C3A----Coordinates and attribute information
C
         XCOORD=XGCNTR+XCOORD
       IF(IVIEW.LE.0) THEN
          YCOORD=YGCNTR+(-1.0*YCOORD)
       ELSE
          YCOORD=YGCNTR+YCOORD
       ENDIF
         WRITE(OUTUNT,'(10X,
     &                  ''CALCULATED COORDINATES      '',
     &                  2(F20.3,1X))')
     &               XCOORD,
     &               YCOORD
C
C3A----Check vertex coordinates and model boundaries
C
       IF(IVIEW.GE.1 .AND. IVIEW.LE.3) THEN
        IF(YCOORD.LT.YGRDMN) THEN
         IF(XCOORD.NE.XGCNTR) THEN
            SLOPE=(YCOORD-YGCNTR)/(XCOORD-XGCNTR)
            BINTRP=YGCNTR-SLOPE*XGCNTR
            XCOORD=(YCOORD-BINTRP)/SLOPE
            YCOORD=YGRDMN
         ELSE
            YCOORD=YGRDMN
         ENDIF
        ENDIF
        IF(YCOORD.GT.YGRDMX) THEN
         IF(XCOORD.NE.XGCNTR) THEN
            SLOPE=(YCOORD-YGCNTR)/(XCOORD-XGCNTR)
            BINTRP=YGCNTR-SLOPE*XGCNTR
            XCOORD=(YCOORD-BINTRP)/SLOPE
            YCOORD=YGRDMX
         ELSE
            YCOORD=YGRDMX
         ENDIF
        ENDIF
        IF(XCOORD.LT.0.0) THEN
         IF(YCOORD.NE.YGCNTR) THEN
            SLOPE=(YCOORD-YGCNTR)/(XCOORD-XGCNTR)
            BINTRP=YGCNTR-SLOPE*XGCNTR
            YCOORD=BINTRP
            XCOORD=0.0
         ELSE
            XCOORD=0.0
         ENDIF
        ENDIF
        IF(XCOORD.GT.XGRDMX) THEN
         IF(YCOORD.NE.YGCNTR) THEN
            SLOPE=(YCOORD-YGCNTR)/(XCOORD-XGCNTR)
            BINTRP=YGCNTR-SLOPE*XGCNTR
            YCOORD=XGRDMX*SLOPE+BINTRP
            XCOORD=XGRDMX
         ELSE
            XCOORD=XGRDMX
         ENDIF
        ENDIF
       ENDIF
C
         WRITE(OUTUNT,'(10X,
     &                  ''POLYGON VERTEX COORDINATES  '',
     &                  2(F20.3,1X))')
     &               XCOORD,
     &               YCOORD
         WRITE(OUTUNT,'(/)')
C
C3C----Record coordinates and attribute information
C
        IF(.NOT. LAB) WRITE(IOUT(7),'(I11)') OLDSTP
C
         WRITE(IOUT(7),'(F20.10,'','',F20.10)')
     &                                        XCOORD,
     &                                        YCOORD
C
C3D----Store label coordinates and attribute information
C
        IF(PRTRAD.GT.RADMAX .AND. PRTSTP.EQ.OLDSTP) THEN
           RADMAX=PRTRAD
           XLABEL=XCOORD
           YLABEL=YCOORD
         WRITE(OUTUNT,'(10X,
     &                  ''POLYGON LABEL COORDINATES   '',
     &                  2(F20.3,1X))')
     &               XLABEL,
     &               YLABEL
        ENDIF
C
C3E----Store first coordinates
C
        IF(.NOT. LAB) THEN
           XCOORD1=XCOORD
           YCOORD1=YCOORD
           LAB=.TRUE.
        ENDIF
C
C3F---Write Time point
C
          IDPART=LABATR(NUMRAD)
          WRITE(IOUT(5),'(I10,'','',
     &                    F20.10,'','',F20.10)')
     &                                        IDPART,
     &                                        XCOORD,
     &                                        YCOORD
C
C3G---Write Time point attributes
C
          PRTSTP=PARTLE(IDPART,2)
          STRCOL=PARTLE(IDPART,3)
          STRROW=PARTLE(IDPART,4)
          STRLAY=PARTLE(IDPART,5)
          STRIBD=PARTLE(IDPART,6)
          LSTCOL=PARTLE(IDPART,14)
          LSTROW=PARTLE(IDPART,15)
          LSTLAY=PARTLE(IDPART,16)
          LSTIBD=PARTLE(IDPART,17)
          PRECOL=PARTLE(IDPART,25)
          PREROW=PARTLE(IDPART,26)
          PRELAY=PARTLE(IDPART,27)
          PREIBD=PARTLE(IDPART,28)
          FINCOL=PARTLE(IDPART,41)
          FINROW=PARTLE(IDPART,42)
          FINLAY=PARTLE(IDPART,43)
          FINIBD=PARTLE(IDPART,44)
          WRITE(IOUT(3),'(6(I10,'',''),
     &                    6(G16.4,'',''),
     &                    1(G16.3,'',''),
     &                    4(I10,'',''),
     &                    6(G16.4,'',''),
     &                    1(G16.3,'',''),
     &                    4(I10,'',''),
     &                    6(G13.4,'',''),
     &                    2(G13.3,'',''),
     &                    4(G13.7,'',''),
     &                    4(I10,'',''),
     &                    6(G13.4,'',''),
     &                    1(G13.3,'',''),
     &                    4(G14.7,'',''),
     &                    4(G16.7,'',''))')
     &                                  IDPART,
     &                                  PRTSTP,
     &                                  STRROW,
     &                                  STRCOL,
     &                                  STRLAY,
     &                                  STRIBD,
     &                                  (PARTLE(IDPART,M), M=7,13),
     &                                  LSTROW,
     &                                  LSTCOL,
     &                                  LSTLAY,
     &                                  LSTIBD,
     &                                  (PARTLE(IDPART,M), M=18,24),
     &                                  PREROW,
     &                                  PRECOL,
     &                                  PRELAY,
     &                                  PREIBD,
     &                                  (PARTLE(IDPART,M), M=29,40),
     &                                  FINROW,
     &                                  FINCOL,
     &                                  FINLAY,
     &                                  FINIBD,
     &                                  (PARTLE(IDPART,M), M=45,55),
     &                                  (PARTLE(IDPART,M), M=56,59)
  300 CONTINUE
      WRITE(OUTUNT,'(5X,96(''-''))')
      WRITE(IOUT(7),'(F20.10,'','',F20.10)')
     &                                        XCOORD1,
     &                                        YCOORD1
      WRITE(IOUT(7),'(''END'')')
C
C3H---Write ZOT polygon label coordinate and attributes
C
      IF(OLDSTP.LE.0) THEN
         XLABEL=XGCNTR
         YLABEL=YGCNTR
      ELSE
         XRADUS=XLABEL-XGCNTR
         YRADUS=YLABEL-YGCNTR
         PRTRAD=(XRADUS**2.0+YRADUS**2.0)**0.5
         RADIUS=ABS(YRADUS/PRTRAD)
C
C3Ha----Compute quadrant for ZOT polygon label coordinate
C
       IF(XRADUS.LT.0.0) THEN
        IF(YRADUS.GT.0.0) THEN
           PRTDEG=ASIN(RADIUS)/0.01745329
           PRTDEG=180.0-ABS(PRTDEG)
        ELSE IF(YRADUS.LT.0.0) THEN
           PRTDEG=ASIN(RADIUS)/0.01745329
           PRTDEG=180.0+ABS(PRTDEG)
        ELSE
           PRTDEG=180.0
        ENDIF
       ELSE IF(XRADUS.EQ.0.0) THEN
        IF(YRADUS.GT.0.0) THEN
           PRTDEG=90.0
        ELSE
           PRTDEG=270.0
        ENDIF
       ELSE
        IF(YRADUS.GT.0.0) THEN
           PRTDEG=ASIN(RADIUS)/0.01745329
        ELSE IF(YRADUS.LT.0.0) THEN
           PRTDEG=ASIN(RADIUS)/0.01745329
           PRTDEG=360.0-PRTDEG
        ELSE
           PRTDEG=0.0
        ENDIF
       ENDIF
C
         PRTDEG=PRTDEG*0.01745329
         XLABEL=XGCNTR+0.999*PRTRAD*COS(PRTDEG)
         YLABEL=YGCNTR+0.999*PRTRAD*SIN(PRTDEG)
      ENDIF
C
C3Ha----Check label coordinates and model boundaries
C
       IF(IVIEW.GE.1 .AND. IVIEW.LE.3) THEN
        IF(YLABEL.LT.CLLMIN) THEN
         IF(XLABEL.NE.XGCNTR) THEN
            SLOPE=(YLABEL-YGCNTR)/(XLABEL-XGCNTR)
            BINTRP=YGCNTR-SLOPE*XGCNTR
            XLABEL=(YLABEL-BINTRP)/SLOPE
            YLABEL=CLLMIN
         ELSE
            YLABEL=CLLMIN
         ENDIF
        ENDIF
        IF(YLABEL.GT.CLLMAX) THEN
         IF(XLABEL.NE.XGCNTR) THEN
            SLOPE=(YLABEL-YGCNTR)/(XLABEL-XGCNTR)
            BINTRP=YGCNTR-SLOPE*XGCNTR
            XLABEL=(YLABEL-BINTRP)/SLOPE
            YLABEL=CLLMAX
         ELSE
            YLABEL=CLLMAX
         ENDIF
        ENDIF
        IF(XLABEL.LT.0.0) THEN
         IF(YLABEL.NE.YGCNTR) THEN
            SLOPE=(YLABEL-YGCNTR)/(XLABEL-XGCNTR)
            BINTRP=YGCNTR-SLOPE*XGCNTR
            YLABEL=BINTRP
            XLABEL=0.0
         ELSE
            XLABEL=0.0
         ENDIF
        ENDIF
        IF(XLABEL.GT.GRDMAX) THEN
         IF(YLABEL.NE.YGCNTR) THEN
            SLOPE=(YLABEL-YGCNTR)/(XLABEL-XGCNTR)
            BINTRP=YGCNTR-SLOPE*XGCNTR
            YLABEL=GRDMAX*SLOPE+BINTRP
            XLABEL=GRDMAX
         ELSE
            XLABEL=GRDMAX
         ENDIF
        ENDIF
       ENDIF
C
C3Hb----Record ZOT polygon label
C
      WRITE(IOUT(6),'(I10,'','',F20.10,'','',F20.10)')
     &                                        TOTSTP,
     &                                        XLABEL,
     &                                        YLABEL
      WRITE(IOUT(4),'(2(I10,'',''))')
     &                            TOTSTP,
     &                            OLDSTP
C**********************************************************************C
C<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>C
C                  Return to Calling Program
C<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>C
C**********************************************************************C
 1000 RETURN
      END
C**********************************************************************C
C<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>C
C                    Output_ZOT Subroutine
C<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>C
C**********************************************************************C
      SUBROUTINE SHAPE_ZOT (
     I                      OUTUNT,
     I                      IOUT,FILES,MAXFIL,
     I                      MAXATB,MAXPTS,MAXDEG,
     I                      XCOORDS,
     I                      YCOORDS,
     I                      PARTLE,
     E                      *)
C-----------------------------------------------------------------------
C
C---VERSION 6.0 SHAPE_ZOT 07NOVEMBER2000
C
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C .. Purpose:
C
C     Records coordinates and attributes for the polygon coverage of
C      ZOTs (Zone_Of_Transport) and a point coverage of the particles 
C      that were used to construct the polygon coverage of ZOTs.  
C
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
C .. Language: FORTRAN
C
C
C    Inputs:
C
C     MAXATB  : MAXIMUM DIMENSION OF THE NUMBER OF ARC, POINT, OR POLYGON
C                ATTRIBUTES IN ARC/INFO FILE
C     MAXPTS  : MAXIMUM DIMENSION OF THE NUMBER OF LABEL
C     OUTUNT  : FORTRAN UNIT WHERE OPERATIONAL OUTPUT AND ERRORS ARE RECORDED
C
C   Inputs/Outputs: None
C
C    Outputs:
C
C     PARTLE  : ARC ATTRIBUTE ARRAY (MAXPTS,MAXATB)
C
C-------------------------------------------------------------------------
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
C
C::::::::::::::::::::::::  GLOBAL_VARIABLES  :::::::::::::::::::::::::::
C
C
      CHARACTER*80 FILES(MAXFIL)
C
      DIMENSION 
     2          PARTLE(MAXPTS,MAXATB)
C
      INTEGER 
     I        OUTUNT,
     I        IOUT(MAXFIL)
C
C
C::::::::::::::::::::::::  PROGRAM_VARIABLES  ::::::::::::::::::::::::::
C
      CHARACTER*80 ZOTFIL,INPFIL,TMPFIL,BUFLIN
C
      REAL 
     &     XCOORD,YCOORD,
     &     XCOORD1,YCOORD1
C
      INTEGER 
     &        TIMSTP,TOTSTP,ZOTSTP,
     &        IDPART,
     &        STRCOL,STRROW,STRLAY,STRIBD,
     &        PRECOL,PREROW,PRELAY,PREIBD,
     &        FINCOL,FINROW,FINLAY,FINIBD,
     &        PRTSTP
C
C     ------------------------------------------------------------------
C
CH----Print Modtools header
C
      WRITE(OUTUNT,'(10X,85(''-''))')
      WRITE(OUTUNT,'(30X,
     &               ''       ZONES OF TRANSPORT GIS OUTPUT PACKAGE'')')
      WRITE(OUTUNT,'(10X,85(''-''))')
      WRITE(OUTUNT,'(30X,
     &               ''              VERSION 6.0 07NOVEMBER2000 '')')
      WRITE(OUTUNT,'(10X,85(''*''))')
      WRITE(OUTUNT,'(10X,85(''-''))')
      WRITE(OUTUNT,'(30X,
     &               ''                 SHAPE ZOT MODULE '')')
      WRITE(OUTUNT,'(10X,85(''=''))')
      WRITE(OUTUNT,'(//)')
C
C2----Open ZOT coordinates information
C
      NSTAT=1
      ITALK=1
      INPFIL='zotpnts'
      CALL OPEN_FILE (IOUT(6),INPFIL,NSTAT,ITALK,*9999)
C
C2A---Loop to read label points
C
 202   READ(IOUT(6),'(A)',ERR=9990,END=204)
     &                                  BUFLIN
      IF(INDEX(BUFLIN,'END').GT.0) GO TO 204
        READ(BUFLIN,*,ERR=9991)
     &                                  TIMSTP,
     &                                  XCOORD,
     &                                  YCOORD
C
       PARTLE(1,TIMSTP)=TIMSTP
        PARTLE(2,TIMSTP)=XCOORD
         PARTLE(3,TIMSTP)=YCOORD
          GO TO 202
C
 204  CALL CLOSE_FILE (INPFIL,*9999)
C
C2B---Loop to read arcs
C
      INPFIL='zotarcs'
      CALL OPEN_FILE (IOUT(7),INPFIL,NSTAT,ITALK,*9999)
      NUMSTP=0
C
 206  READ(IOUT(7),'(A)',ERR=9992,END=210)
     &                                  BUFLIN
      IF(INDEX(BUFLIN,'END').GT.0) GO TO 206
        READ(BUFLIN,*,ERR=9993)
     &                                  ZOTSTP
C
       NUMSTP=NUMSTP+1
        NUMPTS=4
 208     READ(IOUT(7),'(A)',ERR=9992,END=210)
     &                                  BUFLIN
      IF(INDEX(BUFLIN,'END').GT.0) GO TO 206
        READ(BUFLIN,*,ERR=9993)
     &                                  XCOORD,
     &                                  YCOORD
C
        NUMPTS=NUMPTS+1
         PARTLE(NUMPTS,NUMSTP)=XCOORD
          NUMPTS=NUMPTS+1
           PARTLE(NUMPTS,NUMSTP)=YCOORD
            PARTLE(4,NUMSTP)=NUMPTS
             GO TO 208
C
 210  CALL CLOSE_FILE (INPFIL,*9999)
C
      DO 200 TIMSTP=NUMSTP,1
         NUMPTS=PARTLE(4,TIMSTP)
 200  CONTINUE
C
C3----Write zones-of-transport coordinate information
C
      NSTAT=2
      ITALK=1
      FILES(7)='zotpoly'
      CALL DELETE_FILE (FILES(7),*9999)
      CALL OPEN_FILE (IOUT(7),FILES(7),NSTAT,ITALK,*9999)
C
      DO 300 TIMSTP=NUMSTP,1,-1
         XCOORD=PARTLE(2,TIMSTP)
         YCOORD=PARTLE(3,TIMSTP)
         NUMPTS=PARTLE(4,TIMSTP)
         WRITE(IOUT(7),'(I10,'','',
     &                    F20.10,'','',F20.10)')
     &                                        TIMSTP,
     &                                        XCOORD,
     &                                        YCOORD
         DO 310 NUMRAD=4,(NUMPTS-2),2
            XCOORD=PARTLE(NUMRAD+1,TIMSTP)
            YCOORD=PARTLE(NUMRAD+2,TIMSTP)
            WRITE(IOUT(7),'(F20.10,'','',F20.10)')
     &                                        XCOORD,
     &                                        YCOORD
  310    CONTINUE
         WRITE(IOUT(7),'(''END'')')
  300 CONTINUE
      WRITE(IOUT(7),'(''END'')')
      CALL CLOSE_FILE (FILES(7),*9999)
C
C4----Write zones-of-transport attribute information
C
      NSTAT=1
      ITALK=1
      WRITE(*,'(10X,'' Opening file '',A)') FILES(4)
      CALL OPEN_FILE (IOUT(4),FILES(4),NSTAT,ITALK,*9999)
C
C4A---Loop to read label points
C
      TOTSTP=0
 402   READ(IOUT(4),'(A)',ERR=9990,END=404)
     &                                  BUFLIN
        READ(BUFLIN,*,ERR=9991)
     &                                  NUMZOT,
     &                                  TIMSTP
C
       TOTSTP=TOTSTP+1
        PARTLE(1,TOTSTP)=NUMZOT
         PARTLE(2,TOTSTP)=TIMSTP
          GO TO 402
C
 404  CALL CLOSE_FILE (FILES(4),*9999)
C
      NSTAT=2
      ITALK=1
      CALL DELETE_FILE (FILES(4),*9999)
      CALL OPEN_FILE (IOUT(4),FILES(4),NSTAT,ITALK,*9999)
C
      DO 400 NUMSTP=TOTSTP,1,-1
         NUMZOT=PARTLE(1,NUMSTP)
         TIMSTP=PARTLE(2,NUMSTP)
         WRITE(IOUT(4),'(I10,'','',I10,'','')')
     &                                  NUMZOT,
     &                                  TIMSTP
  400 CONTINUE
       CALL CLOSE_FILE (FILES(4),*9999)
        GO TO 1000
C**********************************************************************C
C<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>C
C                        Program Errors
C<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>C
CE*********************************************************************C
 9990 WRITE(*,
     &      '(//,'' Unable to read line from '',
     &      ''ZOT label point file'')')
      WRITE(OUTUNT,
     &      '(//,'' Unable to read line from '',
     &      ''ZOT label point file'')')
      CALL CLOSE_FILE (FILES(6),*9999)
      GO TO 9999
 9991 WRITE(*,
     &      '(//,'' Unable to read from line in '',
     &      ''ZOT label point file'')')
      WRITE(OUTUNT,
     &      '(//,'' Unable to read from line in '',
     &      ''ZOT label point file'')')
      CALL CLOSE_FILE (FILES(6),*9999)
      GO TO 9999
 9992 WRITE(*,
     &      '(//,'' Unable to read line from '',
     &      ''ZOT arc file'')')
      WRITE(OUTUNT,
     &      '(//,'' Unable to read line from '',
     &      ''ZOT arc file'')')
      CALL CLOSE_FILE (FILES(7),*9999)
      GO TO 9999
 9993 WRITE(*,
     &      '(//,'' Unable to read from line in '',
     &      ''ZOT arc file'')')
      WRITE(OUTUNT,
     &      '(//,'' Unable to read from line in '',
     &      ''ZOT arc file'')')
      CALL CLOSE_FILE (FILES(7),*9999)
 9999 WRITE(*,'(//,
     &          '' Abnormal termination of ZOT_Subroutine'')')
      RETURN 1
C**********************************************************************C
C<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>C
C                  Return to Calling Program
C<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>C
C**********************************************************************C
 1000 RETURN
      END
